SystemOrganization addCategory: #Ocompletion!
SystemOrganization addCategory: #'Ocompletion-ECModel'!
SystemOrganization addCategory: #'Ocompletion-ECSqueak'!
SystemOrganization addCategory: #'Ocompletion-ECView'!

!StringHolder methodsFor: '*Ocompletion' stamp: 'dr 10/30/2008 21:01'!
completionController
	| controller | 
	controller := self triggerEvent: #getCompletionController.
	controller ifNil:[ controller := self initializeCompletionController ].
	^controller! !

!StringHolder methodsFor: '*Ocompletion' stamp: 'ul 11/6/2010 05:33'!
createCompletionController
	
	^(ECPreferences useECompletionInsteadOfOCompletion
		ifFalse: [ OController ]
		ifTrue: [ ECController ])
			model: self
	! !

!StringHolder methodsFor: '*Ocompletion' stamp: 'bar 12/13/2004 16:08'!
guessTypeForName: aString
	^nil! !

!StringHolder methodsFor: '*Ocompletion' stamp: 'lr 7/4/2009 10:42'!
initializeCompletionController
	| controller |
	controller := self createCompletionController.
	self 
		when: #getCompletionController
		evaluate: (MessageSend 
				receiver: controller
				selector: #yourself).
	^ controller! !

!StringHolder methodsFor: '*Ocompletion' stamp: 'bar 11/30/2004 16:08'!
receiverClass
	^nil! !

!Behavior methodsFor: '*Ocompletion' stamp: 'dc 5/8/2007 15:32'!
allSelectorsForCompletionWithout: behaviors
	| selectors |
	selectors := IdentitySet new.
	self withAllSuperclassesDo: [:class | (behaviors includes: class)
											ifFalse: [selectors addAll: class selectors.]].
	^ selectors asOrderedCollection ! !

SystemWindow subclass: #ECHelpMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECView'!

!ECHelpMorph commentStamp: '<historical>' prior: 0!
I am a system window that displays the keybindings of eCompletion. The text is static and generated in the class methods.!

!ECHelpMorph class methodsFor: 'private' stamp: 'bar 3/30/2006 14:27'!
explanationAttributes
	^{TextIndent spaceUsed; tabs: 2}! !

!ECHelpMorph class methodsFor: 'help-text' stamp: 'DamienCassou 12/23/2009 16:25'!
helpText
	| stream |
	stream := TextStream on: Text new.
	self section: 'character completion' on: stream.
	self
		shortcut: 'works on'
		text: ' [] {} () <> '''' ""'
		on: stream.
	self
		shortcut: 'usage 1'
		text: 'enter open character - closing character is entered as well'
		on: stream.
	self
		shortcut: 'usage 2'
		text: 'select some text, enter a smart character and the selected text get surrounded by the opening and closing character.'
		on: stream.
	self section: 'open/close menu' on: stream.
	self
		shortcut: 'ctrl-space or tab'
		text: 'open the completion menu'
		on: stream.
	self
		shortcut: 'ESC'
		text: 'close menu'
		on: stream.
	self
		shortcut: '?, ctl-h'
		text: 'open this help'
		on: stream.
	self section: 'menu navigation' on: stream.
	self
		shortcut: 'Arrows up/down'
		text: 'move the selection up and down'
		on: stream.
	self
		shortcut: 'Page up/down'
		text: 'page up and down'
		on: stream.
	self
		shortcut: 'Home/End'
		text: 'move to first or last page of the menu'
		on: stream.
	self section: 'show details and browse' on: stream.
	self
		shortcut: 'right arrow (detail closed)'
		text: 'show details about the selected item. This may be the type of the variable, the source of a method or the implementors of the selector.'
		on: stream.
	self
		shortcut: 'right arrow (detail open)'
		text: 'open a new browser for the selected item.'
		on: stream.
	self
		shortcut: 'left arrow'
		text: 'close the details'
		on: stream.
	self section: 'changing menu contents' on: stream.
	self
		shortcut: 'ctrl-u'
		text: 'switch to untyped mode in a typed menu'
		on: stream.
	self
		shortcut: 'ctrl-t'
		text: 'filter out methods of class Object in a typed menu. press again to make the reappear.'
		on: stream.
	self
		shortcut: 'alphanumeric character'
		text: 'filter the menu to the given input'
		on: stream.
	self
		shortcut: 'backspace'
		text: 'delete an input character, adjust menu to the new input.'
		on: stream.
	self section: 'inserting completion' on: stream.
	self
		shortcut: 'ctrl-space or tab'
		text: 'close the menu and insert selected completion. if there only one item left in the menu this done automaticly.'
		on: stream.
	^ stream contents! !

!ECHelpMorph class methodsFor: 'private' stamp: 'bar 3/12/2006 12:26'!
section: aString on: aTextStream 
	aTextStream
		withAttributes: self sectionAttributes
		do: [aTextStream nextPutAll: aString].
	aTextStream cr! !

!ECHelpMorph class methodsFor: 'private' stamp: 'bar 3/12/2006 12:14'!
sectionAttributes
	^ {TextEmphasis bold}! !

!ECHelpMorph class methodsFor: 'private' stamp: 'bar 3/12/2006 14:30'!
shortcut: aString text: secondString on: aTextStream 
	aTextStream
		withAttributes: self shortcutAttributes
		do: [aTextStream nextPutAll: aString;
				 cr].
	aTextStream
		withAttributes: self explanationAttributes
		do: [aTextStream nextPutAll: secondString;
				 cr].
! !

!ECHelpMorph class methodsFor: 'private' stamp: 'bar 3/30/2006 14:27'!
shortcutAttributes
	^ {TextIndent spaceUsed; tabs: 1. TextEmphasis italic }! !

!ECHelpMorph methodsFor: 'initialize' stamp: 'bar 3/12/2006 14:26'!
contents
	^self class helpText ! !

!ECHelpMorph methodsFor: 'initialize' stamp: 'bar 3/12/2006 13:04'!
defaultColor
	^ ECMenuMorph backgroundColor! !

!ECHelpMorph methodsFor: 'initialize' stamp: 'bar 3/20/2006 15:35'!
initialize
	"textMorph _ TextMorph new contents: self class helpText;
	yourself.
	self addMorph: textMorph"
	| text |
	super initialize.
	self setLabel: 'eCompletion Keyboard Help'.
	"self height: ECMenuMorph itemHeight * 60."
	text := PluggableTextMorph
				on: self
				text: #contents
				accept: nil
				readSelection: nil
				menu: nil.
	self
		addMorph: text
		frame: (0 @ 0 corner: 1.0 @ 1.0).
	text lock.! !

StandardToolSet subclass: #ECToolSet
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECSqueak'!

!ECToolSet class methodsFor: 'completion' stamp: 'damiencassou 7/29/2009 17:00'!
codeCompletionAround: aBlock textMorph: aTextMorph keyStroke: evt
	| completionAllowed editor stringHolder |
	editor := aTextMorph editor.
	stringHolder := editor ifNotNil: [editor model].
	completionAllowed := ECController allowModel: stringHolder.
	completionAllowed
		ifTrue: [(stringHolder completionController handleKeystrokeBefore: evt editor: editor)
				ifTrue: [^ self]].
	aBlock value.
	"sends to keyStroke event handler, if any"
	"Narrow the completion with any of the keys"
	completionAllowed
		ifTrue: [stringHolder completionController handleKeystrokeAfter: evt editor: editor]! !

!ECToolSet class methodsFor: 'initialization' stamp: 'damiencassou 7/30/2009 19:55'!
register
	"Asks the system to use me when launching completion"
	ToolSet register: self! !

!Workspace methodsFor: '*Ocompletion' stamp: 'ul 9/29/2010 19:39'!
completionAdditionals
	
	bindings ifNil: [ ^#() ].
	^bindings keys asArray replace: [ :each | 
		ECLocalEntry 
			contents: each
			type: #local ]! !

!Workspace methodsFor: '*Ocompletion' stamp: 'ul 11/6/2010 05:33'!
createCompletionController
	
	^(ECPreferences useECompletionInsteadOfOCompletion
		ifFalse: [ OController ]
		ifTrue: [ ECWorkspaceController ])
			model: self
	! !

!Workspace methodsFor: '*Ocompletion' stamp: 'lr 7/4/2009 10:42'!
guessTypeForName: aString 
	| binding |
	bindings ifNotNil: 
		[ binding := bindings 
			at: aString
			ifAbsent: [  ].
		binding ifNotNil: [ ^ binding class ] ].
	^ super guessTypeForName: aString! !

!Debugger methodsFor: '*Ocompletion' stamp: 'JohanBrichau 10/21/2009 19:37'!
guessTypeForName: aString 
	| index object |
	index := (self selectedContext debuggerMap tempNamesForContext: self selectedContext)
				indexOf: aString
				ifAbsent: [].
	object := index
				ifNil: [index := self receiver class allInstVarNames
								indexOf: aString
								ifAbsent: [].
						index ifNil: [^ nil].
					self receiver instVarAt: index]
				ifNotNil: [self selectedContext tempAt: index].
	^ object class
! !

!String methodsFor: '*Ocompletion' stamp: 'lr 7/4/2009 10:42'!
beginsWithEmpty: prefix caseSensitive: aBoolean 
	"Answer whether the receiver begins with the given prefix string. 
	The comparison is case-sensitive."
	| matchTable |
	prefix isEmpty ifTrue: [ ^ true ].
	self size < prefix size ifTrue: [ ^ false ].
	matchTable := aBoolean 
		ifTrue: [ CaseSensitiveOrder ]
		ifFalse: [ CaseInsensitiveOrder ].
	^ (self 
		findSubstring: prefix
		in: self
		startingAt: 1
		matchTable: matchTable) = 1! !

!String methodsFor: '*Ocompletion' stamp: 'lr 7/4/2009 10:42'!
indexOfFirstUppercaseCharacter
	| position found input |
	position := 0.
	found := false.
	input := ReadStream on: self.
	[ input atEnd | found ] whileFalse: 
		[ input next isUppercase ifTrue: [ found := true ].
		position := position + 1 ].
	found 
		ifTrue: [ ^ position ]
		ifFalse: [ ^ 0 ]! !

!String methodsFor: '*Ocompletion' stamp: 'cmm 1/6/2007 21:01'!
occursInWithEmpty: prefix caseSensitive: aBoolean
	"Answer whether the receiver begins with the given prefix string. 
	The comparison is case-sensitive."
	| matchTable |
	prefix isEmpty
		ifTrue: [^ true].
	self size < prefix size
		ifTrue: [^ false].
	 matchTable _ aBoolean
				ifTrue: [CaseSensitiveOrder]
				ifFalse: [CaseInsensitiveOrder].
	^ (self
		findSubstring: prefix
		in: self
		startingAt: 1
		matchTable: matchTable)
		> 0! !

!String methodsFor: '*Ocompletion' stamp: 'lr 7/4/2009 10:42'!
wordBefore: anIndex 
	| sep tok |
	tok := false.
	sep := anIndex.
	[ sep > 0 and: [ (self at: sep) tokenish ] ] whileTrue: 
		[ tok := true.
		sep := sep - 1 ].
	^ tok 
		ifTrue: 
			[ self 
				copyFrom: sep + 1
				to: anIndex ]
		ifFalse: [ String new ]! !

Object subclass: #ECContext
	instanceVariableNames: 'source position theClass ranges completionIndex recurseCount receiverClass completionToken model controller variables selectors typeInfos'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECContext commentStamp: '<historical>' prior: 0!
A completion is started by the ECController. The controller creates me to compute the context of the completion. The most important information about the context are the receiverClass and the completionToken. I create a ECModel or subclass when requested by the 'model' method.

I use SHParser and SHRange to parse the text input.!

!ECContext class methodsFor: 'instance creation' stamp: 'bar 4/11/2005 11:23'!
controller: aECController class: aClass source: aString position: anInteger 
	^ self basicNew initialize
		setController: aECController
		class: aClass
		source: aString
		position: anInteger! !

!ECContext methodsFor: 'private-temporaries' stamp: 'lr 7/4/2009 10:42'!
blockTemporaries
	| blocks range vars |
	blocks := OrderedCollection new.
	1 
		to: completionIndex - 1
		do: 
			[ :index | 
			range := ranges at: index.
			self 
				handleBlockStack: blocks
				with: range.
			range isBlockTemporary ifTrue: 
				[ vars := blocks last.
				vars add: range ] ].
	^ self convertBlocksToVariables: blocks! !

!ECContext methodsFor: 'private-compute-index' stamp: 'RomainRobbes 11/2/2009 07:56'!
checkForZeroPosition
	^ (position = 0
			or: [ranges isEmpty])
		and: [self insertEmptyRangeAt: 1 start: 0 end: 1.
			true]! !

!ECContext methodsFor: 'private-receiver-guessing' stamp: 'bar 1/9/2005 14:55'!
checkImpossibleReceiver
	^ self isSelectorsAndVariables
		ifTrue: [self configureSelectorsAndVariables]
		ifFalse: [self isVariablesOnly
				ifTrue: [self configureVariablesOnly]
				ifFalse: [self isSelectorsOnly
						and: [self configureSelectorsOnly]]]. ! !

!ECContext methodsFor: 'accessing' stamp: 'lr 7/4/2009 10:42'!
completionToken
	completionToken ifNil: 
		[ | range |
		range := ranges at: completionIndex.
		completionToken := self 
			sourceOf: range
			stopAt: position.
		completionToken := completionToken wordBefore: completionToken size ].
	^ completionToken! !

!ECContext methodsFor: 'private' stamp: 'lr 7/4/2009 10:42'!
compute
	completionIndex := self computeIndexOfPosition.
	receiverClass := self computeReceiverClass! !

!ECContext methodsFor: 'private-compute-index' stamp: 'lr 7/4/2009 10:42'!
computeIndexOfPosition
	| current |
	self checkForZeroPosition ifTrue: [ ^ 1 ].
	1 
		to: ranges size
		do: 
			[ :index | 
			current := ranges at: index.
			(current includesPosition: position) 
				ifTrue: [ ^ index ]
				ifFalse: 
					[ current end > position ifTrue: [ ^ self createEmptyRangeForGapAt: index ] ] ].
	^ self createEmptyRangeAtTail! !

!ECContext methodsFor: 'private' stamp: 'bar 1/9/2005 11:35'!
computeReceiverClass
	| previous found |
	recurseCount := 0.
	completionIndex = 1 ifTrue: [^nil].
	found := self checkImpossibleReceiver.
	found ifTrue: [^nil].
	previous := ranges at: completionIndex - 1.
	previous type = #cascadeSeparator 
		ifTrue: [^self guessCascadeReceiver: completionIndex - 1].
	(previous type = #unary 
		and: [(self sourceOf: previous) = 'new' and: [completionIndex > 2]]) 
			ifTrue: 
				[previous := ranges at: completionIndex - 2.
				previous type = #globalVar 
					ifTrue: [^self guessTypeOf: completionIndex - 2]
					ifFalse: 
						[self configureSelectorsOnly.
						^nil]].
	^self guessTypeOf: completionIndex - 1! !

!ECContext methodsFor: 'private-configure' stamp: 'bar 1/9/2005 11:35'!
configureSelectorsAndVariables
	variables := true.
	selectors := true.
	^true! !

!ECContext methodsFor: 'private-configure' stamp: 'bar 1/9/2005 11:35'!
configureSelectorsOnly
	variables := false.
	selectors := true.
	^true! !

!ECContext methodsFor: 'private-configure' stamp: 'bar 1/9/2005 11:34'!
configureVariablesOnly
	variables := true.
	selectors := false.
	^true! !

!ECContext methodsFor: 'private-temporaries' stamp: 'lr 7/4/2009 10:42'!
convertBlocksToVariables: anOrderedCollection 
	| result blockStack |
	blockStack := anOrderedCollection.
	result := OrderedCollection new.
	blockStack do: [ :each | result addAll: each ].
	^ result! !

!ECContext methodsFor: 'private-compute-index' stamp: 'lr 7/4/2009 10:42'!
createEmptyRangeAtTail
	| previous |
	previous := ranges last.
	ranges add: (SHRange 
			start: previous end + 1
			end: source size
			type: #empty).
	^ ranges size! !

!ECContext methodsFor: 'private-compute-index' stamp: 'RomainRobbes 11/2/2009 07:57'!
createEmptyRangeForGapAt: index 
	| current previous |
	index = 1 ifTrue: [self insertEmptyRangeAt: 1 start: 0 end: 1. ^ index].
	current := ranges at: index.
	previous := ranges at: index - 1.
	self 
		insertEmptyRangeAt: index
		start: previous end + 1
		end: current start - 1.
	^ index! !

!ECContext methodsFor: 'accessing' stamp: 'dr 10/30/2008 17:15'!
createModel
	| modelClass |
	self receiverClass
		ifNotNil: [^ ECTypedModel class: receiverClass].
	(controller workspace isNil
		and: [theClass notNil])
		ifTrue: [completionIndex = 1
				ifTrue: [^ ECOverrideModel class: theClass]].
			
	modelClass := ECUntypedModel.		
	(controller model respondsTo: #modelClass) ifTrue: [controller model modelClass ifNotNilDo: [:class | modelClass :=  class]].		
	^ modelClass
		class: theClass
		temporaries: self temporaries
		additionals: controller additionals
		variables: variables
		selectors: selectors! !

!ECContext methodsFor: 'private' stamp: 'bar 1/6/2005 14:35'!
createRanges
	| parser |
	parser := SHParserST80 new.
	ranges := parser 
				rangesIn: source
				classOrMetaClass: theClass
				workspace: controller workspace
				environment: nil.
	ranges := ranges select: [:each | each type ~= #comment]! !

!ECContext methodsFor: 'private-roel-typer' stamp: 'lr 3/26/2010 15:04'!
findCommonSuperclass: aCollection
	| current |
	aCollection isEmpty
		ifTrue: [ ^ nil ].
	current := aCollection first.
	aCollection do: [ :class |
		[ class includesBehavior: current ]
			whileFalse: [ current := current superclass ] ].
	^ current! !

!ECContext methodsFor: 'private' stamp: 'bar 1/9/2005 14:51'!
findSourceRangeFor: aNumber 
	aNumber
		to: ranges size
		by: 2
		do: [:index | 
			index + 3 > ranges size
				ifTrue: [^ nil].
			(ranges at: index + 1) isAssignment
				ifTrue: [(ranges at: index + 3) type = #statementSeparator
						ifTrue: [^ index + 2]
						ifFalse: [(ranges at: index + 2) type = #globalVar
								ifTrue: [^ index + 2]
								ifFalse: [(ranges at: index + 1) isAssignment 
										ifFalse: [^ nil]]]]]! !

!ECContext methodsFor: 'private-type-guessing' stamp: 'lr 7/4/2009 10:42'!
guessArgument: aSHRange 
	| name |
	name := self sourceOf: aSHRange.
	(name = 'html' and: [ (Smalltalk 
		at: #WARenderCanvas
		ifAbsent: [  ]) notNil ]) ifTrue: [ ^ Smalltalk at: #WARenderCanvas ].
	^ ECInstVarTypeGuesser getClassFromTypeSuggestingName: name! !

!ECContext methodsFor: 'private' stamp: 'lr 7/4/2009 10:42'!
guessCascadeReceiver: aNumber 
	| type |
	aNumber 
		to: 1
		by: -1
		do: 
			[ :index | 
			type := (ranges at: index) type.
			((#(#statementSeparator #assignment #ansiAssignment ) includes: type) or: [ (type beginsWith: 'pattern') or: [ type beginsWith: 'methodTemp' ] ]) ifTrue: [ ^ self guessTypeOf: index + 1 ] ].
	^ nil! !

!ECContext methodsFor: 'private' stamp: 'damiencassou 7/18/2009 08:05'!
guessClassVarClass: aSHRange 
	| aClass name |
	name := self sourceOf: aSHRange.
	aClass := controller guessTypeFor: name.
	aClass
		ifNotNil: [^ aClass].
	^ (ECClassVarTypeGuesser variableName: name class: theClass theMetaClass) perform! !

!ECContext methodsFor: 'private-type-guessing' stamp: 'lr 7/4/2009 10:42'!
guessGlobal: aNumber 
	| aClass |
	aClass := Smalltalk 
		at: (self sourceOf: (ranges at: aNumber)) asSymbol
		ifAbsent: [ ^ nil ].
	aClass isBehavior ifFalse: [ ^ nil ].
	aNumber = (completionIndex - 1) ifTrue: [ ^ aClass class ].
	(ranges size >= (aNumber + 1) and: [ (ranges at: aNumber + 1) type = #statementSeparator ]) ifTrue: [ ^ aClass class ].
	^ aClass! !

!ECContext methodsFor: 'private' stamp: 'lr 7/4/2009 10:42'!
guessInstVarClass: aSHRange 
	| aClass name |
	name := self sourceOf: aSHRange.
	aClass := controller guessTypeFor: name.
	aClass ifNotNil: [ ^ aClass ].
	aClass := self 
		guessWithRoelTyper: name
		class: theClass.
	aClass ifNotNil: [ ^ aClass ].
	^ (ECInstVarTypeGuesser 
		variableName: name
		class: theClass) perform! !

!ECContext methodsFor: 'private' stamp: 'bar 3/1/2006 13:52'!
guessTempVarClass: aSHRange 
	^self guessTempVarClass: (self sourceOf: aSHRange) type: aSHRange type.
! !

!ECContext methodsFor: 'private' stamp: 'lr 7/4/2009 10:42'!
guessTempVarClass: aString type: aSymbol 
	| current type varName varType sourceIndex aClass |
	aClass := controller guessTypeFor: aString.
	aClass ifNotNil: [ ^ aClass ].
	varName := aString.
	varType := aSymbol.
	1 
		to: completionIndex
		do: 
			[ :index | 
			current := ranges at: index.
			(current type = varType and: [ (self sourceOf: current) = varName and: [ index + 3 <= ranges size ] ]) ifTrue: 
				[ (sourceIndex := self findSourceRangeFor: index) notNil ifTrue: 
					[ type := self guessTypeOf: sourceIndex.
					type ifNotNil: [ ^ type ] ] ] ].
	^ nil! !

!ECContext methodsFor: 'private-type-guessing' stamp: 'ul 10/27/2010 04:40'!
guessTypeOf: aNumber

	| range |
	self configureSelectorsOnly.
	recurseCount > 10 ifTrue: [ ^ nil ].
	recurseCount := recurseCount + 1.
	range := ranges at: aNumber.
	range isSelf ifTrue: [ ^theClass ].
	range isSuper ifTrue: [ ^theClass ifNotNil: [ theClass superclass ] ].
	range isConstant ifTrue: [ ^range asType ].
	range isArgument ifTrue: [ ^self guessArgument: range ].
	range isTemporaryVariable ifTrue: [ ^self guessTempVarClass: range ].
	range isInstanceVariable ifTrue: [ ^self guessInstVarClass: range ].
	range isClassVariable ifTrue: [ ^self guessClassVarClass: range ].
	range isGlobal ifTrue: [ ^self guessGlobal: aNumber ].
	^nil! !

!ECContext methodsFor: 'private-roel-typer' stamp: 'lr 3/26/2010 15:16'!
guessWithRoelTyper: aString class: aClass 
	| typeCollector typeClass typeInfo types type |
	typeCollector := Smalltalk classNamed: #TypeCollector.
	typeCollector ifNil: [ ^ nil ].
	typeClass := aClass whichClassDefinesInstVar: aString.
	typeClass ifNil: [ ^ nil ].
	typeInfo := (typeCollector typeInstvarsOfClass: typeClass)
		at: aString asSymbol
		ifAbsent: [ ^ nil ].
	types := typeInfo types size <= 2
		ifTrue: [ typeInfo types ]
		ifFalse: [ typeInfo types intersection: typeInfo assignments ].
	type := types isEmpty
		ifFalse: [ self findCommonSuperclass: types ].
	^ type == Object 
		ifFalse: [ type ]! !

!ECContext methodsFor: 'private-temporaries' stamp: 'lr 7/4/2009 10:42'!
handleBlockStack: aCollection with: aSHRange 
	| range blockStack |
	range := aSHRange.
	blockStack := aCollection.
	range isBlockStart 
		ifTrue: [ blockStack add: OrderedCollection new ]
		ifFalse: [ range isBlockEnd ifTrue: [ blockStack removeLast ] ]! !

!ECContext methodsFor: 'initialize-release' stamp: 'lr 7/4/2009 10:42'!
initialize
	super initialize.
	source := String new.
	position := 0.
	recurseCount := 0.
	variables := true.
	selectors := true.
	ranges := OrderedCollection new.
	completionIndex := 0.
	completionToken := nil! !

!ECContext methodsFor: 'private-compute-index' stamp: 'bar 1/6/2005 22:04'!
insertEmptyRangeAt: index start: start end: end 
	ranges
		add: (SHRange
				start: start
				end: end
				type: #empty)
		beforeIndex: index! !

!ECContext methodsFor: 'private-receiver-guessing' stamp: 'bar 1/9/2005 11:33'!
isSelectorsAndVariables
	| current |
	current := ranges at: completionIndex.
	^current isUnfinished! !

!ECContext methodsFor: 'private-receiver-guessing' stamp: 'bar 1/9/2005 11:33'!
isSelectorsOnly
	| previous |
	previous := ranges at: completionIndex - 1.
	^previous isOpening! !

!ECContext methodsFor: 'private-receiver-guessing' stamp: 'lr 7/4/2009 10:42'!
isVariablesOnly
	| current previous |
	current := ranges at: completionIndex.
	^ current isVariablesOnly or: 
		[ current isOpening or: 
			[ previous := ranges at: completionIndex - 1.
			previous isOpening or: 
				[ previous isSeparator or: 
					[ previous isKeyword or: [ previous isAssignment or: [ previous isBinary ] ] ] ] ] ]! !

!ECContext methodsFor: 'accessing' stamp: 'lr 7/4/2009 10:42'!
model
	model isNil ifTrue: [ model := self createModel ].
	^ model! !

!ECContext methodsFor: 'action' stamp: 'lr 7/4/2009 10:42'!
narrowWith: aString 
	completionToken := aString.
	model ifNotNil: [ model narrowWith: aString ]! !

!ECContext methodsFor: 'private' stamp: 'bar 12/13/2004 15:32'!
receiverClass
	^ receiverClass! !

!ECContext methodsFor: 'initialize-release' stamp: 'lr 7/4/2009 10:42'!
setController: aECController class: aClass source: aString position: anInteger 
	controller := aECController.
	theClass := aClass.
	source := aString.
	position := anInteger.
	self createRanges.
	self compute! !

!ECContext methodsFor: 'private' stamp: 'bar 3/1/2006 13:25'!
sourceOf: aSHRange 
	^aSHRange isString
		ifTrue: [aSHRange]
		ifFalse: [self sourceOf: aSHRange stopAt: aSHRange end]! !

!ECContext methodsFor: 'private' stamp: 'bar 12/18/2004 23:55'!
sourceOf: aSHRange stopAt: aNumber
	^ aSHRange type = #empty
		ifTrue: [String new]
		ifFalse: [source copyFrom: aSHRange start to: aNumber]! !

!ECContext methodsFor: 'action' stamp: 'bar 1/9/2005 11:35'!
switchToUntyped
	receiverClass := nil.
	self configureSelectorsAndVariables.
	model := self createModel! !

!ECContext methodsFor: 'accessing' stamp: 'lr 7/4/2009 10:42'!
temporaries
	| tempRanges |
	tempRanges := ranges select: [ :each | #(#patternTempVar #patternArg ) includes: each type ].
	tempRanges addAll: self blockTemporaries.
	^ tempRanges collect: 
		[ :each | 
		ECLocalEntry 
			contents: (self sourceOf: each)
			type: each type ]! !

!ECContext methodsFor: 'accessing' stamp: 'bar 2/26/2006 09:04'!
theClass
	^theClass! !

!ECContext methodsFor: 'private-roel-typer' stamp: 'lr 7/4/2009 10:42'!
typeInfosFor: aClass 
	| roelTyper |
	(roelTyper := Smalltalk 
		at: #TypeCollector
		ifAbsent: [  ]) ifNil: [ ^ nil ].
	typeInfos ifNil: [ typeInfos := roelTyper typeInstvarsOfClass: aClass ].
	^ typeInfos! !

ECContext subclass: #OContext
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion'!

!OContext methodsFor: 'model creation' stamp: 'rr 4/15/2009 15:30'!
createModel
	| mdl |		
	mdl := OModel
		class: theClass
		temporaries: self temporaries
		additionals: controller additionals
		variables: variables
		selectors: selectors.
	controller expanded ifTrue: [mdl expand].
	^ mdl ! !

Object subclass: #ECController
	instanceVariableNames: 'model menuMorph editor context oppositeChar caret inverseMapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECView'!

!ECController commentStamp: '<historical>' prior: 0!
I live as an instance variable in a Browser, Debugger, Workspace or other window. I'm the glue between all participants of the completion system. I create the ECContext and pass myself to the ECMenuMorph. I process the keyboard events and pass them to the ECMenuMorph or close the morph if needed.!

!ECController class methodsFor: 'testing' stamp: 'lr 5/11/2010 12:54'!
allowModel: aModel 
	^ aModel respondsTo: #completionController! !

!ECController class methodsFor: 'instance creation' stamp: 'bar 12/13/2004 12:05'!
model: aStringHolder 
	^self new setModel: aStringHolder! !

!ECController methodsFor: 'accessing' stamp: 'bar 12/16/2004 11:13'!
additionals
	^ nil! !

!ECController methodsFor: 'menu morph' stamp: 'bar 12/13/2004 15:09'!
closeMenu
	menuMorph
		ifNotNil: [menuMorph delete]! !

!ECController methodsFor: 'accessing' stamp: 'bar 12/13/2004 12:08'!
context
	^context! !

!ECController methodsFor: 'accessing' stamp: 'ul 12/6/2010 22:06'!
editor

	^editor ifNotNil: [ editor at: 1 ]
! !

!ECController methodsFor: 'accessing' stamp: 'ul 12/6/2010 22:06'!
editor: theEditor

	(editor ifNil: [ editor := WeakArray new: 1 ])
		at: 1 put: theEditor
! !

!ECController methodsFor: 'type guessing' stamp: 'ul 10/29/2010 05:54'!
guessTypeFor: aString 

	^self model ifNotNil: [ :theModel |
		theModel guessTypeForName: aString ]! !

!ECController methodsFor: 'keyboard' stamp: 'bar 1/6/2005 08:57'!
handleKeystrokeAfter: aKeyboardEvent editor: aParagraphEditor 
	(aParagraphEditor isNil or:[self isMenuOpen not]) ifTrue:[^self].
	self setModel: aParagraphEditor model.
			context narrowWith: aParagraphEditor wordAtCaret.
			menuMorph narrowCompletion! !

!ECController methodsFor: 'keyboard' stamp: 'klub 11/23/2010 13:06'!
handleKeystrokeBefore: aKeyboardEvent editor: aParagraphEditor 
	"I return a boolean. true when I have handled the event and no futher 
	processing 
	is needed by the caller."
	
	| theEditor keyValue controlKeyPressed isSpaceKey |
	self editor: aParagraphEditor. 
	theEditor := self editor.
	self setModel: theEditor model.
	keyValue := aKeyboardEvent keyValue.
	controlKeyPressed := aKeyboardEvent controlKeyPressed.
	isSpaceKey := #(0 32 ) includes: keyValue.
	"Ctrl-Space or Tab for open"
	self isMenuOpen
		ifFalse: [(isSpaceKey & controlKeyPressed
					or: [keyValue = 9
							and: [theEditor isCaretBehindChar
									and: [controlKeyPressed not]]])
				ifTrue: [self openMenuFor: theEditor.
					^ true]
				ifFalse: [(self smartInput: keyValue)
						ifNotNil: [^ true]].
			^ false].
	"Home"
	keyValue = 1
		ifTrue: [menuMorph home.
			^ true].
	"End"
	(keyValue = 4
			and: [controlKeyPressed not])
		ifTrue: [menuMorph end. 
			^ true].
	(keyValue = 8 and:[controlKeyPressed ]) ifTrue:[menuMorph help. ^true].
	"Right-Arrow"
	keyValue = 29
		ifTrue: [menuMorph showDetail.
			^ true].
	"Left Arrow"
	keyValue = 28
		ifTrue: [menuMorph hideDetail.
			^ true].
	"Arrow up"
	keyValue = 30
		ifTrue: [menuMorph moveUp.
			^ true].
	"Arrow down"
	keyValue = 31
		ifTrue: [menuMorph moveDown.
			^ true].
	"Page up"
	keyValue = 11
		ifTrue: [menuMorph pageUp.
			^ true].
	"Page down"
	keyValue = 12
		ifTrue: [menuMorph pageDown.
			^ true].
	"Tab or Ctrl-Space"
	(keyValue = 13
			or: [isSpaceKey & controlKeyPressed
					or: [keyValue = 9]])
		ifTrue: [menuMorph insertSelected
				ifTrue: [^ true]].
	"Ctrl-u"
	keyValue = 21 & controlKeyPressed
		ifTrue: [menuMorph switchToUntyped.
			^ true].
	"Crtl-t"
	(keyValue = 20
			and: [controlKeyPressed])
		ifTrue: [menuMorph expand.
			^ true].
	"All keys but the alphanumeric chars (without command and control ) 
	and the backspace key do close the menu"
	keyValue = 8
		ifTrue: [theEditor isCaretBehindChar not
				ifTrue: [self closeMenu].
			^ false].
	(controlKeyPressed not & aKeyboardEvent commandKeyPressed not
			and: [aKeyboardEvent keyCharacter isAlphaNumeric])
		ifFalse: [self closeMenu.
			^ keyValue = 27].
	^ false! !

!ECController methodsFor: 'keyboard' stamp: 'klub 11/23/2010 13:01'!
invalidateEditorMorph
	
	| theEditor |
	theEditor := self editor ifNil: [ ^self ].
	theEditor morph invalidRect: theEditor morph bounds.
! !

!ECController methodsFor: 'menu morph' stamp: 'RomainRobbes 10/19/2009 16:58'!
isMenuOpen
	^menuMorph notNil and: [menuMorph itemsCount > 0 ifTrue: [true] ifFalse: [self closeMenu. false]]
! !

!ECController methodsFor: 'menu morph' stamp: 'damiencassou 7/29/2009 15:25'!
menuClosed
	menuMorph := nil.
	context := nil.! !

!ECController methodsFor: 'accessing' stamp: 'RomainRobbes 12/26/2009 19:12'!
model
	^model isArray ifTrue: [model first] ifFalse: [model]! !

!ECController methodsFor: 'menu morph' stamp: 'klub 11/23/2010 13:03'!
openMenuFor: aParagraphEditor 

	| theMenu |
	context := ECContext
				controller: self
				class: self model selectedClassOrMetaClass 
				source: aParagraphEditor text string
				position: aParagraphEditor caret - 1.
	self editor: aParagraphEditor.
	theMenu := ECMenuMorph
				controller: self
				position: (aParagraphEditor selectionPosition: context completionToken).
	theMenu isClosed
		ifFalse: [menuMorph := theMenu]. ! !

!ECController methodsFor: 'initialize-release' stamp: 'RomainRobbes 12/26/2009 19:12'!
setModel: aStringHolder 
	model := WeakArray with: aStringHolder! !

!ECController methodsFor: 'keyboard' stamp: 'klub 11/23/2010 13:01'!
smartBackspace

	| opposite theEditor |
	theEditor := self editor ifNil: [ ^nil ].
	theEditor hasSelection ifTrue: [ ^nil ].
	opposite := self smartCharactersMapping
		at: (theEditor text
			at: theEditor startIndex - 1
			ifAbsent: [ ^ nil ])
		ifAbsent: [ ^ nil ].
	opposite = (theEditor text at: theEditor stopIndex ifAbsent: [ ^ nil ])
		ifFalse: [ ^ nil ].
	theEditor selectInvisiblyFrom: theEditor startIndex - 1 to: theEditor stopIndex.
	theEditor zapSelectionWith: String new.
	self invalidateEditorMorph.
	^ true
	
! !

!ECController methodsFor: 'keyboard' stamp: 'klub 11/23/2010 13:02'!
smartCharacter: aCharacter

	| theEditor opposite previous next |
	theEditor := self editor ifNil: [ ^nil ].
	theEditor hasSelection ifTrue: [
		opposite := self smartCharactersMapping
			at: aCharacter
			ifAbsent: [ ^ nil ].
		theEditor zapSelectionWith: (String with: aCharacter) , (theEditor selection) , (String with: opposite).
		theEditor selectFrom: theEditor stopIndex to: theEditor stopIndex - 1.
		self invalidateEditorMorph.
		^ true ].	
	opposite := self smartCharactersMapping at: aCharacter ifAbsent: [
		self smartInverseMapping
			at: aCharacter
			ifAbsent: [ ^ nil ].
		theEditor blinkPrevParen: aCharacter.
		(theEditor text at: theEditor startIndex ifAbsent: [ ^ nil ]) = aCharacter
			ifFalse: [ ^ nil ].
		theEditor selectFrom: theEditor startIndex + 1 to: theEditor startIndex.
		self invalidateEditorMorph.
		^ true ].
	previous := theEditor text at: theEditor startIndex - 1 ifAbsent: [ Character space ].
	next := theEditor text at: theEditor startIndex ifAbsent: [ Character space ].
	(previous isSeparator or: [ next isSeparator ])
		ifFalse: [ ^ nil ].
	(opposite = aCharacter and: [ next = aCharacter ]) ifTrue: [
		theEditor selectFrom: theEditor startIndex + 1 to: theEditor startIndex.
		self invalidateEditorMorph.
		^ true ].
	theEditor zapSelectionWith: (String with: aCharacter with: opposite).
	theEditor selectFrom: theEditor startIndex + 1 to: theEditor startIndex.
	self invalidateEditorMorph.
	^ true! !

!ECController methodsFor: 'settings' stamp: 'lr 7/31/2010 18:15'!
smartCharacters
	^ ECPreferences smartCharacters ! !

!ECController methodsFor: 'settings' stamp: 'lr 7/31/2010 18:22'!
smartCharactersMapping
	^ ECPreferences smartCharactersMapping ! !

!ECController methodsFor: 'keyboard' stamp: 'RomainRobbes 8/2/2010 18:23'!
smartInput: anInteger 
	self smartCharacters 
		ifFalse: [ ^ nil ].
	^ anInteger = 8
		ifTrue: [ self smartBackspace ]
		ifFalse:  [ self smartCharacter: anInteger asCharacter ]! !

!ECController methodsFor: 'settings' stamp: 'RomainRobbes 8/2/2010 18:22'!
smartInverseMapping
	^ inverseMapping ifNil: [ 
		inverseMapping := Dictionary new.
		self smartCharactersMapping
			keysAndValuesDo: [ :key :value | inverseMapping at: value put: key ].
		inverseMapping ]! !

!ECController methodsFor: 'accessing' stamp: 'bar 12/15/2004 09:23'!
workspace
	^nil! !

ECController subclass: #ECWorkspaceController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECView'!

!ECWorkspaceController commentStamp: '<historical>' prior: 0!
I'm a specialized controller, that works with Workspaces.!

!ECWorkspaceController methodsFor: 'accessing' stamp: 'bar 12/16/2004 11:14'!
additionals
	^ self workspace completionAdditionals! !

!ECWorkspaceController methodsFor: 'accessing' stamp: 'RomainRobbes 12/26/2009 19:10'!
workspace
	^self model! !

ECController subclass: #OController
	instanceVariableNames: 'expanded contextClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion'!

!OController methodsFor: 'as yet unclassified' stamp: 'rr 6/26/2009 14:06'!
closeMenu
	super closeMenu.
	menuMorph := nil! !

!OController methodsFor: 'as yet unclassified' stamp: 'rr 2/13/2009 17:27'!
contextClass
	^ contextClass! !

!OController methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 12/26/2009 19:10'!
expand
	
	expanded := true.
	(self model isKindOf: OModel) ifTrue: [self model expand].! !

!OController methodsFor: 'as yet unclassified' stamp: 'rr 12/11/2007 09:45'!
expanded
	^ expanded ifNil: [expanded := false]! !

!OController methodsFor: 'as yet unclassified' stamp: 'klub 11/23/2010 13:08'!
handleKeystrokeBefore: kbEvent editor: theEditor 
	"I return a boolean. true when I have handled the event and no futher processing is needed by the caller."
	| keyValue ctrl cmd down tab colon alphanum del esc enter up |
	self editor: theEditor.
	self setModel: theEditor model.
	keyValue := kbEvent keyValue.
	ctrl := kbEvent controlKeyPressed.
	cmd := kbEvent commandKeyPressed.
	down := keyValue = 31.
	up := keyValue = 30.
	tab := kbEvent keyCharacter = Character tab.
	enter := kbEvent keyCharacter = Character cr.
	colon := kbEvent keyCharacter = $:.
	alphanum := kbEvent keyCharacter isAlphaNumeric.
	del := keyValue = 8.
	esc := keyValue = 27.

	self isMenuOpen ifTrue: [menuMorph stillActive].

	del	ifTrue: [ self smartBackspace ].
	self expanded ifTrue: [ ^ super handleKeystrokeBefore: kbEvent editor: theEditor ].
	
	esc ifTrue: [self isMenuOpen ifTrue: [self retract; closeMenu. ^ true]].
	
	((tab) and: [theEditor wordAtCaret notEmpty]) ifTrue: [
		(context notNil and: [context model notEmpty and: [menuMorph selected > 0]]) 
				ifTrue: [menuMorph insertSelected ifTrue: [ ^ true ] ]
				ifFalse: [enter ifFalse: [self openXMenuFor: theEditor. ^true]]].		
	
	self isMenuOpen & (colon | alphanum | up | down | tab | del) not ifTrue: [self retract; closeMenu.].
	
	
	del	ifTrue: [ theEditor isCaretBehindChar not
						ifTrue: [ self closeMenu ].
					^ false].

	(ctrl not & cmd not & alphanum) 
		ifTrue: [ 
			theEditor selection ifNotEmpty: [theEditor replaceSelectionWith: ''].
			self isMenuOpen ifFalse: [ self openMenuFor: theEditor ].
			theEditor text ifNotNil: [ menuMorph changed ]. ^false]
		ifFalse: [
			(self smartInput: keyValue) ifNotNil: [^ true]].
		
	down & self isMenuOpen ifTrue: [
			
			menuMorph selected = 3 ifTrue: [self openXMenuFor: theEditor].
			menuMorph moveDown.
			^ true ].
	
	up & self isMenuOpen ifTrue:  [
		
		menuMorph moveUp.
		^ true]. 
	
	^ super handleKeystrokeBefore: kbEvent editor: theEditor 
! !

!OController methodsFor: 'as yet unclassified' stamp: 'rr 4/15/2009 10:27'!
initialize
	contextClass := OContext.! !

!OController methodsFor: 'as yet unclassified' stamp: 'rr 4/17/2009 14:35'!
menuMorph
	^ self expanded ifTrue: [OXMenuMorph] ifFalse: [OMenuMorph]! !

!OController methodsFor: 'as yet unclassified' stamp: 'klub 11/23/2010 13:06'!
openMenuFor: aParagraphEditor 
	| theMenu |
	self closeMenu.
	context := self contextClass 
				controller: self
				class: self model selectedClassOrMetaClass
				source: aParagraphEditor text string
				position: aParagraphEditor caret - 1.
	
	self editor: aParagraphEditor.
	theMenu := self menuMorph controller: self
				position: (aParagraphEditor selectionPosition: context completionToken).
	theMenu isClosed ifFalse: [menuMorph := theMenu].
	! !

!OController methodsFor: 'as yet unclassified' stamp: 'klub 11/23/2010 13:06'!
openXMenuFor: aParagraphEditor 
	| theMenu |
	self closeMenu.
	context := menuMorph 
		ifNotNil: [menuMorph context] 
		ifNil: [self contextClass 
				controller: self
				class: self model selectedClassOrMetaClass
				source: aParagraphEditor text string
				position: aParagraphEditor caret - 1].
	
	self editor: aParagraphEditor.
	self expand.
	theMenu := self menuMorph controller: self
				position: (aParagraphEditor selectionPosition: context completionToken).
	theMenu isClosed ifFalse: [menuMorph := theMenu].
	menuMorph moveDown; moveDown. 
	! !

!OController methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 12/26/2009 19:10'!
retract
	expanded := false.
	(self model isKindOf: OModel) ifTrue: [self model contract].! !

Object subclass: #ECEntry
	instanceVariableNames: 'contents type description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECEntry commentStamp: 'bar 10/5/2005 23:31' prior: 0!
I represent a completion entry that is management by a ECModel and shown in the ECMenuMorph as a menu entry.!

ECEntry subclass: #ECClassVarEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECClassVarEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:27'!
guessTypeWith: anECContext 
	^ anECContext guessClassVarClass: contents! !

!ECClassVarEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:40'!
label
	^ 'class variable'! !

!ECEntry class methodsFor: 'as yet unclassified' stamp: 'bar 8/13/2005 18:55'!
contents: aString type: aSymbol
	^ self new setContents: aString type: aSymbol! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 10/5/2005 22:35'!
<= aECEntry 
	^ contents <= aECEntry contents! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'lr 3/29/2008 10:39'!
browseWith: anECContext 
	type := self guessTypeWith: anECContext.
	type
		ifNil: [^ false].
	SystemNavigation default
		browseClass: type.
	^ true! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 8/14/2005 21:44'!
completion
	^ self contents asSymbol! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 8/13/2005 18:56'!
contents
	^contents! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 10/5/2005 22:36'!
contentsAsSymbol
	^ contents asSymbol ! !

!ECEntry methodsFor: 'detail information' stamp: 'lr 7/4/2009 10:42'!
createDescriptionWith: anECContext 
	| clazz |
	clazz := self guessTypeWith: anECContext.
	^ clazz 
		ifNil: [ ECEntryDescription label: self label ]
		ifNotNil: 
			[ ECEntryDescription 
				label: self label
				title: clazz printString
				description: clazz comment ]! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'lr 7/4/2009 10:42'!
descriptionWith: anECContext 
	description ifNotNil: [ ^ description ].
	^ description := self createDescriptionWith: anECContext! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:27'!
guessTypeWith: anECContext 
	^ nil! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/2/2006 17:50'!
isInstance
	^ false! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/2/2006 17:51'!
isLocal
	^ false! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/2/2006 17:51'!
isSelector
	^ false! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:40'!
label
	^ 'unknown'! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 8/13/2005 19:08'!
printOn: aStream 
	aStream nextPutAll: self class name;
		 nextPut: $(;
		 nextPutAll: contents;
		 nextPut: $,;
		 nextPutAll: type;
		 nextPut: $)! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'lr 7/4/2009 10:42'!
setContents: aString type: aSymbol 
	contents := aString.
	type := aSymbol! !

!ECEntry methodsFor: 'as yet unclassified' stamp: 'bar 8/13/2005 18:56'!
type
	^type! !

ECEntry subclass: #ECGlobalEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECGlobalEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/20/2006 15:20'!
guessTypeWith: anECContext 
	| globalEntry |
	globalEntry := Smalltalk at: contents ifAbsent: [^ nil].
	globalEntry isBehavior ifTrue: [^ globalEntry].
	globalEntry ifNotNil: [^ globalEntry class].
	^ nil! !

!ECGlobalEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:41'!
label
	^ 'global'! !

ECEntry subclass: #ECInstVarEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECInstVarEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:27'!
guessTypeWith: anECContext 
	^ anECContext guessInstVarClass: contents! !

!ECInstVarEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/2/2006 17:51'!
isInstance
^true! !

!ECInstVarEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:41'!
label
	^ 'instance variable'! !

ECEntry subclass: #ECLocalEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECLocalEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:27'!
guessTypeWith: anECContext 
	^ (anECContext guessTempVarClass: contents type: type) 
		ifNil: [anECContext guessArgument: contents]! !

!ECLocalEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/2/2006 17:51'!
isLocal
	^true! !

!ECLocalEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:41'!
label
	^ 'local variable'! !

ECEntry subclass: #ECSelectorEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECSelectorEntry methodsFor: 'private' stamp: 'damiencassou 1/6/2009 14:04'!
browseWith: anECContext
	^ self
		findMethodWith: anECContext
		do: [ :class :method | 
			Browser fullOnClass: class selector: method selector.
			true ]
		ifAbsent: [ :selector | 
			(SystemBrowser default name beginsWith: 'OB')
				ifTrue: [OBImplementorsBrowser openRoot: (OBSelectorNode on: selector).]
				ifFalse: [self systemNavigation browseAllImplementorsOf: selector].
				true ]! !

!ECSelectorEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/8/2006 21:42'!
createDescriptionWith: anECContext 
	^ self
		findMethodWith: anECContext
		do: [:clazz :method | self
				methodSourceDescription: clazz
				method: method
				]
		ifAbsent: [:selector | self implementorsDescription: selector]! !

!ECSelectorEntry methodsFor: 'private' stamp: 'bar 3/20/2006 16:15'!
findMethodWith: anECContext do: foundBlock ifAbsent: notfoundBlock 
	| theClass result implementors |
	theClass := anECContext model theClass.
	result := theClass
				ifNil: [implementors := self systemNavigation allImplementorsOf: contents.
					implementors size == 1
						ifTrue: [| ref | 
							ref := implementors first.
							self lookupSelector: ref methodSymbol class: ref actualClass]
						ifFalse: [^ notfoundBlock value: contents]]
				ifNotNil: [self lookupSelector: contents class: theClass]. 
	^ foundBlock value: result first value: result second! !

!ECSelectorEntry methodsFor: 'private' stamp: 'lr 7/4/2009 10:42'!
implementorsDescription: aSymbol 
	| implementors output |
	output := WriteStream on: String new.
	implementors := self systemNavigation allImplementorsOf: aSymbol.
	implementors isEmpty ifTrue: 
		[ ^ ECEntryDescription 
			label: 'symbol'
			title: '(no implementors)'
			description: 'This is just symbol.' ].
	implementors do: 
		[ :each | 
		output
			nextPutAll: each classSymbol printString;
			cr ].
	^ ECEntryDescription 
		label: self label
		title: '(Implementors)'
		description: output contents! !

!ECSelectorEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/2/2006 21:52'!
label
	^ 'method'! !

!ECSelectorEntry methodsFor: 'private' stamp: 'bar 3/20/2006 15:38'!
lookupSelector: aSymbol class: aClass 
	"Look up the given selector in my methodDictionary.
	Return the corresponding method if found.
	Otherwise chase the superclass chain and try again.
	Return nil if no method is found."
	| lookupClass |
	lookupClass := aClass.
	[lookupClass isNil]
		whileFalse: [(lookupClass includesSelector: aSymbol)
				ifTrue: [^ Array
						with: lookupClass
						with: (lookupClass compiledMethodAt: aSymbol)].
			lookupClass := lookupClass superclass].
	^ nil! !

!ECSelectorEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/30/2006 14:17'!
methodSourceDescription: aClass method: aCompiledMethod 
	| styler |
	styler := SHTextStylerST80 new.
	styler classOrMetaClass: aClass.
	^ ECEntryDescription
		label: self label
		title: aClass printString
		description: (styler styledTextFor: (self methodSourceOn: aCompiledMethod ) asText)! !

!ECSelectorEntry methodsFor: 'private' stamp: 'rjl 12/11/2008 21:07'!
methodSourceOn: aCompiledMethod 
	^ aCompiledMethod getSourceFor: aCompiledMethod selector
		in: aCompiledMethod methodClass! !

ECSelectorEntry subclass: #ODatedEntry
	instanceVariableNames: 'date next previous'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion'!

!ODatedEntry methodsFor: 'as yet unclassified' stamp: 'rr 2/21/2009 11:49'!
<= anEntry
	^ date = anEntry date 
		ifTrue: [contents <= anEntry contents]
		ifFalse: [date > anEntry date]! !

!ODatedEntry methodsFor: 'as yet unclassified' stamp: 'rr 2/21/2009 11:49'!
date
	^ date! !

!ODatedEntry methodsFor: 'as yet unclassified' stamp: 'rr 4/9/2009 15:38'!
date: d
	date := d! !

!ODatedEntry methodsFor: 'as yet unclassified' stamp: 'ul 9/27/2010 05:12'!
link: anODatedEntry
	"Link the given entry after me."

	anODatedEntry
		next: next;
		previous: self.
	next previous: anODatedEntry.
	next := anODatedEntry! !

!ODatedEntry methodsFor: 'as yet unclassified' stamp: 'ul 9/27/2010 05:38'!
matches: pref

	^contents beginsWithEmpty: pref caseSensitive: false! !

!ODatedEntry methodsFor: 'as yet unclassified' stamp: 'ul 9/27/2010 05:07'!
next

	^next! !

!ODatedEntry methodsFor: 'as yet unclassified' stamp: 'ul 9/27/2010 05:08'!
next: anODatedEntry

	next := anODatedEntry! !

!ODatedEntry methodsFor: 'as yet unclassified' stamp: 'rr 4/9/2009 15:32'!
now
	date := DateAndTime now! !

!ODatedEntry methodsFor: 'as yet unclassified' stamp: 'ul 9/27/2010 05:07'!
previous

	^previous! !

!ODatedEntry methodsFor: 'as yet unclassified' stamp: 'ul 9/27/2010 05:08'!
previous: anODatedEntry

	previous := anODatedEntry! !

!ODatedEntry methodsFor: 'as yet unclassified' stamp: 'ul 9/27/2010 05:08'!
unlink

	next previous: previous.
	previous next: next! !

ECEntry subclass: #ECSelfEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECSelfEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:27'!
guessTypeWith: anECContext 
	^ anECContext theClass! !

!ECSelfEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:42'!
label
	^ 'self'! !

ECEntry subclass: #ECSuperEntry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECSuperEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:27'!
guessTypeWith: anECContext 
	^ anECContext theClass ifNotNil: [anECContext theClass superclass]! !

!ECSuperEntry methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:42'!
label
	^ 'super'! !

Object subclass: #ECEntryDescription
	instanceVariableNames: 'title description label'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECEntryDescription class methodsFor: 'as yet unclassified' stamp: 'bar 3/2/2006 22:01'!
label: firstString 
	^ self new
		setLabel: firstString
		title: '(unknown)'
		description: nil! !

!ECEntryDescription class methodsFor: 'as yet unclassified' stamp: 'bar 3/1/2006 15:39'!
label: firstString title: secondString description: thirdString 
	^ self new 
		setLabel: firstString
		title: secondString
		description: thirdString! !

!ECEntryDescription methodsFor: 'accessing' stamp: 'bar 3/2/2006 22:02'!
description
(	description isNil or:[description isEmpty]) ifTrue:[^'-'].
	^ description! !

!ECEntryDescription methodsFor: 'accessing' stamp: 'bar 3/1/2006 15:39'!
label
	^ label! !

!ECEntryDescription methodsFor: 'initialize-release' stamp: 'lr 7/4/2009 10:42'!
setLabel: firstString title: secondString description: thirdString 
	label := firstString.
	title := secondString.
	description := thirdString! !

!ECEntryDescription methodsFor: 'accessing' stamp: 'bar 3/1/2006 15:20'!
title
^ title! !

Object subclass: #ECModel
	instanceVariableNames: 'clazz selectors narrowString entries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECModel commentStamp: '<historical>' prior: 0!
I'm an abstract class that stores the entries to be completed.!

!ECModel class methodsFor: 'instance creation' stamp: 'lr 7/4/2009 10:42'!
class: aClass 
	| newInstance |
	newInstance := self basicNew initialize.
	newInstance setClass: aClass.
	^ newInstance! !

!ECModel methodsFor: 'accessing' stamp: 'cmm 12/9/2010 14:27'!
addToEntries: anOrderedCollection 
	| frontMatching innerMatching caseSensitive matchSubStrings |
	caseSensitive := ECPreferences caseSensitive.
	matchSubStrings := ECPreferences matchSubStrings.
	frontMatching := OrderedCollection new.
	innerMatching := OrderedCollection new.
	anOrderedCollection do:
		[ : each | (each contents
			beginsWithEmpty: narrowString
			caseSensitive: caseSensitive)
			ifTrue: [ frontMatching add: each ]
			ifFalse:
				[ matchSubStrings ifTrue:
					[ (each contents
						occursInWithEmpty: narrowString
						caseSensitive: caseSensitive) ifTrue: [ innerMatching add: each ] ] ] ].
	frontMatching sort.
	innerMatching sort.
	entries
		 addAll: frontMatching ;
		 addAll: innerMatching! !

!ECModel methodsFor: 'accessing' stamp: 'bar 12/4/2004 17:21'!
at: aNumber 
	^ entries at: aNumber ! !

!ECModel methodsFor: 'action' stamp: 'dr 10/30/2008 21:05'!
completionAt: aNumber
	^ (self at: aNumber) completion separateKeywords , ' '! !

!ECModel methodsFor: 'accessing' stamp: 'bar 12/4/2004 17:20'!
entries
	^entries! !

!ECModel methodsFor: 'accessing' stamp: 'lr 7/4/2009 10:42'!
entriesOfType: aSymbol 
	| collection |
	collection := entries select: [ :each | each type == aSymbol ].
	^ collection collect: [ :each | each contents ]! !

!ECModel methodsFor: 'accessing' stamp: 'bar 12/4/2004 17:21'!
entryCount
	^entries size! !

!ECModel methodsFor: 'accessing' stamp: 'bar 12/17/2004 22:45'!
hasMessage
	^ self message notNil! !

!ECModel methodsFor: 'initialize-release' stamp: 'bar 4/11/2005 11:22'!
initialize
	self reset! !

!ECModel methodsFor: 'accessing' stamp: 'bar 12/6/2004 14:18'!
initializeSelectors 
	self subclassResponsibility ! !

!ECModel methodsFor: 'testing' stamp: 'bar 3/3/2006 17:00'!
isEmpty
	^ entries isEmpty! !

!ECModel methodsFor: 'accessing' stamp: 'bar 1/6/2005 08:25'!
message
	^self isEmpty ifTrue: ['no completions found'] ifFalse: [nil]! !

!ECModel methodsFor: 'private' stamp: 'bar 12/4/2004 17:40'!
narrowString: aString 
	narrowString := aString! !

!ECModel methodsFor: 'action' stamp: 'bar 12/6/2004 11:53'!
narrowWith: aString
	self subclassResponsibility ! !

!ECModel methodsFor: 'testing' stamp: 'bar 12/4/2004 17:22'!
notEmpty 
	^self isEmpty not! !

!ECModel methodsFor: 'private' stamp: 'lr 7/4/2009 10:42'!
reset
	self resetSelectors.
	self resetEntries.
	narrowString := String new! !

!ECModel methodsFor: 'private' stamp: 'lr 7/4/2009 10:42'!
resetEntries
	entries := OrderedCollection new! !

!ECModel methodsFor: 'private' stamp: 'ul 9/26/2010 19:23'!
resetSelectors
	selectors
		ifNil: [ selectors := OrderedCollection new: 500 ]
		ifNotNil: [ selectors reset ]! !

!ECModel methodsFor: 'initialize-release' stamp: 'bar 1/6/2005 08:54'!
setClass: aClass 
	clazz := aClass.
	self initializeSelectors.
	self narrowWith: String new! !

!ECModel methodsFor: 'action' stamp: 'bar 3/1/2006 15:48'!
theClass
	^nil! !

!ECModel methodsFor: 'action' stamp: 'bar 12/6/2004 14:44'!
title
	^nil! !

!ECModel methodsFor: 'initialize-release' stamp: 'bar 12/5/2004 23:17'!
toggleExpand
	! !

ECModel subclass: #ECTypedModel
	instanceVariableNames: 'expanded'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECTypedModel commentStamp: '<historical>' prior: 0!
I'm the model for a typed completion, that means when a receiver class is known. I only have selectors. I have an expand toggle: When false I filter out Object and ProtoObject selectors. The default value is true.!

ECTypedModel subclass: #ECOverrideModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECOverrideModel commentStamp: '<historical>' prior: 0!
I'm used when completing a method override. I contain all selectors of the superclass minus the already implemented selectors of the current class. When a completion occurs I complete a method template with a send to super.!

!ECOverrideModel methodsFor: 'action' stamp: 'ul 10/29/2010 06:10'!
completionAt: aNumber 
	| output source declaration |
	source := self methodSourceAt: aNumber.
	declaration := (source lineCorrespondingToIndex: 1)
		withoutTrailingBlanks.
	output := WriteStream on: String new.
	output nextPutAll: declaration; cr; tab.
	(source includesSubString: 'subclassResponsibility') ifFalse: [
		(source includes: $^)
			ifTrue: [ output nextPut: $^ ].
		output
			nextPutAll: 'super ';
			nextPutAll: declaration ].
	^ output contents! !

!ECOverrideModel methodsFor: 'private' stamp: 'bar 12/6/2004 16:51'!
computeReturn: aString
	| lastLine |
	lastLine := aString lineCorrespondingToIndex: aString size.
	^(lastLine
				detect: [:each | each = $^]
				ifNone: [])
				ifNil: ['']
				ifNotNil: ['^'].
! !

!ECOverrideModel methodsFor: 'initialize-release' stamp: 'lr 7/4/2009 10:42'!
initializeSelectors
	self initializeSelectorsFor: clazz superclass.
	clazz methodDictionary keysDo: 
		[ :each | 
		| entry |
		entry := selectors 
			detect: [ :ea | ea contentsAsSymbol == each ]
			ifNone: [  ].
		entry notNil ifTrue: 
			[ selectors 
				remove: entry
				ifAbsent: [  ] ] ]! !

!ECOverrideModel methodsFor: 'private' stamp: 'lr 6/19/2010 12:49'!
methodAt: aNumber 
	^ clazz lookupSelector: (self at: aNumber) contentsAsSymbol! !

!ECOverrideModel methodsFor: 'private' stamp: 'ul 10/29/2010 06:02'!
methodSourceAt: aNumber 
	
	^(self methodAt: aNumber) getSource asString! !

!ECOverrideModel methodsFor: 'action' stamp: 'bar 12/6/2004 15:02'!
title
	^ '(override) ' , clazz superclass name! !

!ECTypedModel methodsFor: 'initialize-release' stamp: 'cmm 1/6/2007 21:03'!
initialize
	super initialize.
	expanded := false.
! !

!ECTypedModel methodsFor: 'private' stamp: 'bar 12/6/2004 14:19'!
initializeSelectors
	self initializeSelectorsFor: clazz! !

!ECTypedModel methodsFor: 'private' stamp: 'lr 3/17/2010 19:50'!
initializeSelectorsFor: aClass 
	|excludedClasses|
	selectors reset.
	excludedClasses := (expanded ifTrue: [#()] ifFalse: [Object withAllSuperclasses]).
	selectors addAll: ((aClass allSelectorsForCompletionWithout: excludedClasses)
						collect: [:each | ECSelectorEntry contents: each type: #selector])! !

!ECTypedModel methodsFor: 'action' stamp: 'cmm 1/6/2007 21:49'!
narrowWith: aString 
	self
		narrowString: aString ;
		initializeSelectors.
	entries reset.
	self addToEntries: selectors! !

!ECTypedModel methodsFor: 'action' stamp: 'bar 3/1/2006 15:49'!
theClass
	^clazz! !

!ECTypedModel methodsFor: 'action' stamp: 'bar 12/6/2004 14:44'!
title
	^clazz name! !

!ECTypedModel methodsFor: 'action' stamp: 'lr 7/4/2009 10:42'!
toggleExpand
	expanded := expanded not.
	self initializeSelectors.
	self narrowWith: narrowString! !

ECModel subclass: #ECUntypedModel
	instanceVariableNames: 'instVars localVars includeVariables includeSelectors classVars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECUntypedModel commentStamp: '<historical>' prior: 0!
When no receiver class is known, I'm the right model. I store all temporary variables, instance variables of the selected class and all selectors in system. For performance reasons I only collect selectors when at least one character is known.!

ECUntypedModel subclass: #ECUnseparatedModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECUnseparatedModel methodsFor: 'action' stamp: 'dr 10/30/2008 17:06'!
completionAt: aNumber 
	^ (self at: aNumber) completion! !

!ECUntypedModel class methodsFor: 'instance creation' stamp: 'bar 12/20/2004 09:02'!
class: aClass temporaries: aCollection 
	^self 
		class: aClass
		temporaries: aCollection
		additionals: #()
		variables: true
		selectors: true! !

!ECUntypedModel class methodsFor: 'instance creation' stamp: 'lr 7/4/2009 10:42'!
class: aClass temporaries: aCollection additionals: additionalCollection variables: variablesBoolean selectors: selectorsBoolean 
	| newInstance |
	newInstance := self basicNew initialize.
	newInstance 
		setClass: aClass
		temporaries: aCollection
		additionals: additionalCollection
		variables: variablesBoolean
		selectors: selectorsBoolean.
	^ newInstance! !

!ECUntypedModel methodsFor: 'private' stamp: 'ul 10/29/2010 02:11'!
addAdditionals: aCollection 

	aCollection ifNil: [ ^self ].
	aCollection do: [ :each |
		each isLocal
			ifTrue: [ localVars add: each value ]
			ifFalse: [
				each isInstance
					ifTrue: [ instVars add: each value ]
					ifFalse: [ 
						each isSelector ifTrue: [ selectors add: each value ] ] ] ]! !

!ECUntypedModel methodsFor: 'private' stamp: 'ul 9/29/2010 19:01'!
addSelectors

	self
		initializeSelectors;
		addToEntries: selectors! !

!ECUntypedModel methodsFor: 'private' stamp: 'bar 10/5/2005 23:05'!
addVariables
	includeVariables
		ifFalse: [^ self].
	self addToEntries: localVars.
	self addToEntries: instVars.
	self addToEntries: classVars! !

!ECUntypedModel methodsFor: 'initialize-release' stamp: 'ul 9/27/2010 04:54'!
initialize
	super initialize.
	localVars := OrderedCollection new.
	instVars := OrderedCollection new.
	classVars := OrderedCollection new.
	includeSelectors := true.
	includeVariables := true! !

!ECUntypedModel methodsFor: 'initialize-release' stamp: 'ul 10/29/2010 06:04'!
initializeClassVars

	(clazz isNil or: [ includeVariables not ]) ifTrue: [ ^ self ].
	classVars := clazz theNonMetaClass allClassVarNames asOrderedCollection replace: [ :each | 
		ECClassVarEntry
			contents: each
			type: #classVar ]! !

!ECUntypedModel methodsFor: 'initialize-release' stamp: 'ul 9/27/2010 04:49'!
initializeInstVars
	(clazz isNil or: [ includeVariables not ]) ifTrue: [ ^ self ].
	instVars := clazz allInstVarNames asOrderedCollection replace: [ :each | 
		ECInstVarEntry 
			contents: each
			type: #instVar ].
	instVars add: (ECSelfEntry 
			contents: 'self'
			type: #self).
	instVars add: (ECSuperEntry 
			contents: 'super'
			type: #super)! !

!ECUntypedModel methodsFor: 'private' stamp: 'MarianoMartinezPeck 5/16/2010 15:51'!
initializeSelectors
	self resetSelectors.
	includeSelectors ifFalse: 
		[ Smalltalk environment keysDo: 
			[ :each | 
			selectors add: (ECGlobalEntry 
					contents: each
					type: #globalVar) ].
		^ self ].
	narrowString ifEmpty: [ ^ self ].
	ECSymbols 
		contains: narrowString
		caseSensitive: ECPreferences caseSensitive
		do: 
			[ :each | 
			(includeVariables or: [ each first isLowercase ]) ifTrue: 
				[ selectors add: (ECSelectorEntry 
						contents: each
						type: #selector).
				selectors size > 500 ifTrue: [ ^ self ] ] ]! !

!ECUntypedModel methodsFor: 'accessing' stamp: 'cmm 1/8/2007 21:01'!
message
	^ (includeSelectors and: [ narrowString isEmpty ]) 
		ifTrue: 
			[ selectors size = 500 
				ifTrue: [ 'more...' ]
				ifFalse: [ 'press key for selectors' ] ]
		ifFalse: [ super message ]! !

!ECUntypedModel methodsFor: 'initialize-release' stamp: 'bar 4/11/2005 11:42'!
narrowString: aString 
	(narrowString isEmpty
			or: [aString isEmpty
			or: [aString first ~= narrowString first]])
		ifTrue: [self reset].
	super narrowString: aString! !

!ECUntypedModel methodsFor: 'action' stamp: 'bar 4/11/2005 11:35'!
narrowWith: aString 
	self narrowString: aString.
	self resetEntries.
	self addVariables.
	self addSelectors! !

!ECUntypedModel methodsFor: 'initialize-release' stamp: 'TestRunner 12/3/2009 13:24'!
noVariables
	includeVariables := false.! !

!ECUntypedModel methodsFor: 'initialize-release' stamp: 'lr 7/4/2009 10:42'!
setClass: aClass temporaries: aCollection additionals: additionalCollection variables: variablesBoolean selectors: selectorsBoolean 
	includeVariables := variablesBoolean.
	includeSelectors := selectorsBoolean.
	clazz := aClass.
	self initializeInstVars.
	self initializeClassVars.
	includeVariables 
		ifTrue: 
			[ localVars := aCollection.
			self addAdditionals: additionalCollection ]
		ifFalse: [ localVars := OrderedCollection new ].
	self
		resetEntries;
		addVariables;
		addSelectors! !

ECUntypedModel subclass: #OModel
	instanceVariableNames: 'table expand nextModel cachedEntries ctable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion'!

!OModel methodsFor: 'accessing' stamp: 'rr 5/28/2009 11:29'!
addEntry: ent
	(self tableForEntry: ent) addEntry: ent ! !

!OModel methodsFor: 'accessing' stamp: 'rr 4/14/2009 13:56'!
addSelectors
	! !

!OModel methodsFor: 'accessing' stamp: 'damiencassou 7/27/2009 14:22'!
at: aNumber
	
	^ self entries at: (aNumber max: 1) ! !

!OModel methodsFor: 'accessing' stamp: 'rr 5/28/2009 14:17'!
completionAt: aNumber
	| entry |
	"when an entry is selected, update its date (for inlined messages which do not appear in the method's body"
	entry := (self at: aNumber) completion.
	self addEntry: entry.
	^ entry separateKeywords, ' '.! !

!OModel methodsFor: 'accessing' stamp: 'rr 4/15/2009 13:28'!
contract
	expand := false.
	nextModel := nil.! !

!OModel methodsFor: 'accessing' stamp: 'RomainRobbes 8/2/2010 17:58'!
entries
	| ent more |
	entries ifNotEmpty: [^expand not & (entries size > 3) ifTrue: [entries first: 3] ifFalse: [entries ]].
	ent := (narrowString notEmpty and: [narrowString first isUppercase]) 
					ifTrue: [ctable entriesMatching: narrowString] 
					ifFalse: [includeSelectors 
										ifTrue: [table entriesMatching: narrowString]
										ifFalse: [ent := super entries]].
	ent := ent asOrderedCollection.
	ent size > 7 ifTrue: [ent := ent first: 7. ].
	 ent addAll: (self nextModel entries reject: [:e | ent anySatisfy: [:ea | ea contents = e contents]]).
	entries := ent.
	^ expand not & (ent size > 3) ifTrue: [ent first: 3] ifFalse: [ent]! !

!OModel methodsFor: 'accessing' stamp: 'RomainRobbes 8/2/2010 17:56'!
entryCount
	^ self entries size! !

!OModel methodsFor: 'accessing' stamp: 'rr 4/15/2009 13:28'!
expand
	expand := true.! !

!OModel methodsFor: 'accessing' stamp: 'rr 5/28/2009 11:15'!
initialize
	super initialize.
	self contract.
	table := OCompletionTable default.
	ctable := OCompletionTable classes.! !

!OModel methodsFor: 'accessing' stamp: 'rr 4/14/2009 13:56'!
initializeSelectors! !

!OModel methodsFor: 'accessing' stamp: 'rr 4/17/2009 14:33'!
narrowWith: aString
	self narrowString: aString.
	self resetEntries.
	self addVariables.
	self nextModel ifNotNilDo: [:nm | nm narrowWith: aString].! !

!OModel methodsFor: 'accessing' stamp: 'rr 4/14/2009 17:01'!
nextModel
	^ expand 
		ifTrue: [nextModel ifNil: [nextModel := ECUntypedModel class: clazz temporaries: localVars additionals: #() variables: includeVariables selectors: includeSelectors. nextModel narrowWith: narrowString] ifNotNil: [nextModel]]
		ifFalse: [OEmptyModel new]! !

!OModel methodsFor: 'accessing' stamp: 'rr 4/17/2009 15:28'!
noNextModel
	nextModel := OEmptyModel new.! !

!OModel methodsFor: 'accessing' stamp: 'TestRunner 11/30/2009 14:07'!
resetEntries
	super resetEntries.
	"table ifNotNil: [table reset].
	ctable ifNotNil: [ctable reset]"! !

!OModel methodsFor: 'accessing' stamp: 'rr 4/14/2009 13:46'!
table
	^ table! !

!OModel methodsFor: 'accessing' stamp: 'rr 5/28/2009 14:18'!
tableForEntry: ent
	^ (ent notEmpty and: [ent first isUppercase]) 
			ifTrue: [ctable]
			ifFalse: [table]! !

!OModel methodsFor: 'accessing' stamp: 'rr 4/14/2009 17:11'!
useUniqueTable
	table := OCompletionTable new entriesPerPrefix: 20.
	! !

Object subclass: #ECPreferences
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECSqueak'!

ECPreferences class
	instanceVariableNames: 'enabled caseSensitive smartCharacters smartCharactersMapping useECompletionInsteadOfOCompletion matchSubStrings'!

ECPreferences class
	instanceVariableNames: 'enabled caseSensitive smartCharacters smartCharactersMapping useECompletionInsteadOfOCompletion matchSubStrings'!

!ECPreferences class methodsFor: 'accessing' stamp: 'ul 10/26/2010 22:53'!
caseSensitive

	<preference: 'Case Sensitive'
		category: 'OCompletion'
		description: 'Decide if you want OCompletion to be case sensitive or not.'
		type: #Boolean>
	^ caseSensitive
! !

!ECPreferences class methodsFor: 'accessing' stamp: 'TestRunner 3/17/2010 20:03'!
caseSensitive: aBoolean
	caseSensitive := aBoolean! !

!ECPreferences class methodsFor: 'accessing' stamp: 'ul 10/26/2010 21:50'!
enabled
	
	<preference: 'Enable OCompletion'
		category: 'OCompletion'
		description: 'Enable or disable OCompletion in browsers, debuggers and workspaces.'
		type: #Boolean>
	^ enabled
! !

!ECPreferences class methodsFor: 'accessing' stamp: 'TestRunner 3/17/2010 20:03'!
enabled: aBoolean
	enabled := aBoolean! !

!ECPreferences class methodsFor: 'initialization' stamp: 'lr 5/11/2010 12:52'!
initialize
	enabled := caseSensitive := smartCharacters := true.
	smartCharactersMapping := Dictionary new.
	smartCharactersMapping
		at: $( put: $);
		at: $[ put: $];
		at: ${ put: $};
		at: $" put: $";
		at: $' put: $'! !

!ECPreferences class methodsFor: 'accessing' stamp: 'ul 10/27/2010 03:12'!
listFont

	Smalltalk at: #StandardFonts ifPresent: [ :standardFonts |
		"Pharo"
		^standardFonts listFont ].
	Smalltalk at: #Preferences ifPresent: [ :preferences |
		"Squeak"
		^preferences standardListFont ]! !

!ECPreferences class methodsFor: 'accessing' stamp: 'cmm 12/9/2010 14:26'!
matchSubStrings

	<preference: 'Match SubStrings'
		category: 'OCompletion'
		description: 'Decide if you want OCompletion to perform subString searches, which can be slower, rather than only front-matching selectors.'
		type: #Boolean>
	^ matchSubStrings ifNil: [ false ]! !

!ECPreferences class methodsFor: 'accessing' stamp: 'cmm 12/9/2010 14:26'!
matchSubStrings: aBoolean

	matchSubStrings := aBoolean! !

!ECPreferences class methodsFor: 'accessing' stamp: 'ul 10/27/2010 03:14'!
menuFont

	Smalltalk at: #StandardFonts ifPresent: [ :standardFonts |
		"Pharo"
		^standardFonts menuFont ].
	Smalltalk at: #Preferences ifPresent: [ :preferences |
		"Squeak"
		^preferences standardMenuFont ]! !

!ECPreferences class methodsFor: 'accessing' stamp: 'ul 10/27/2010 03:16'!
menuSelectionColor

	Smalltalk at: #UITheme ifPresent: [ :uiTheme |
		"Pharo"
		^uiTheme current settings selectionColor ].
	Smalltalk at: #Preferences ifPresent: [ :preferences |
		"Squeak"
		^preferences menuSelectionColor ]! !

!ECPreferences class methodsFor: 'settings' stamp: 'ul 11/6/2010 05:57'!
settingsOn: aBuilder 
	<systemsettings>
	
	(aBuilder setting: #'OCompletion: Code Completion') 
		target: self; 
		parentName: #codeBrowsing;
		selector: #enabled;
		icon: MenuIcons smallConfigurationIcon;
		description: 'Enable or disable code completion in browsers, debuggers and workspaces.';
		with: [
			(aBuilder setting: #caseSensitive) 
				label: 'Case Sensitive';
		 		description: 'Decide if you want OCompletion to be case sensitive or not.'.
			(aBuilder setting: #smartCharacters) 
				label: 'Smart Characters';
		 		description: 'Decide if you want OCompletion to use smart characters, e.g, to automatically close brackets.'.
			(aBuilder setting: #useECompletionInsteadOfOCompletion)
				label: 'Use eCompletion instead of OCompletion';
				description: 'Decide if you want to use eCompletion in newly opened tools instead of OCompletion.' ]! !

!ECPreferences class methodsFor: 'accessing' stamp: 'ul 10/26/2010 21:51'!
smartCharacters

	<preference: 'Smart Characters'
		category: 'OCompletion'
		description: 'Decide if you want OCompletion to use smart characters, e.g, to automatically close brackets.'
		type: #Boolean>
	^ smartCharacters! !

!ECPreferences class methodsFor: 'accessing' stamp: 'TestRunner 3/17/2010 20:03'!
smartCharacters: aBoolean
	smartCharacters := aBoolean! !

!ECPreferences class methodsFor: 'accessing' stamp: 'lr 5/11/2010 12:51'!
smartCharactersMapping
	^ smartCharactersMapping! !

!ECPreferences class methodsFor: 'accessing' stamp: 'lr 5/11/2010 12:52'!
smartCharactersMapping: aDictionary
	smartCharactersMapping := aDictionary! !

!ECPreferences class methodsFor: 'accessing' stamp: 'ul 11/6/2010 05:32'!
useECompletionInsteadOfOCompletion

	<preference: 'Use eCompletion instead of OCompletion'
		category: 'OCompletion'
		description: 'Decide if you want to use eCompletion in newly opened tools instead of OCompletion.'
		type: #Boolean>
	^useECompletionInsteadOfOCompletion ifNil: [ false ]
! !

!ECPreferences class methodsFor: 'accessing' stamp: 'ul 11/6/2010 05:28'!
useECompletionInsteadOfOCompletion: aBoolean

	useECompletionInsteadOfOCompletion := aBoolean
! !

Object subclass: #ECSymbols
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECSqueak'!

!ECSymbols class methodsFor: 'as yet unclassified' stamp: 'ul 9/27/2010 06:03'!
contains: aString caseSensitive: aBoolean do: aBlock 

	| separators |
	separators := CharacterSet separators.
	Symbol allSymbolTablesDo: [ :each | 
		((each indexOfAnyOf: separators startingAt: 1) = 0 and: [
			each 
				includesSubstring: aString
				caseSensitive: aBoolean]) ifTrue: [ aBlock value: each ] ]! !

Object subclass: #ECTypeInfo
	instanceVariableNames: 'type kind temporaryOffset'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECTypeInfo commentStamp: '<historical>' prior: 0!
I'm used in ECInstVarTypeGuesser to store found type informations.!

!ECTypeInfo class methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 11:52'!
definedByLiteral: aClass 
	| newInstance |
	newInstance := self new.
	newInstance setType: aClass kind: 1.
	^ newInstance! !

!ECTypeInfo class methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 11:52'!
definedByMessageSend: aClass 
	| newInstance |
	newInstance := self new.
	newInstance setType: aClass kind: 2.
	^ newInstance! !

!ECTypeInfo class methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 12:02'!
definedByTemporaryVar: anInteger
	| newInstance |
	newInstance := self new.
	newInstance setType: nil kind: 3.
	newInstance temporaryOffset: anInteger.
	^ newInstance! !

!ECTypeInfo methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 11:47'!
isDefinedByMessageSend
	^kind == 2! !

!ECTypeInfo methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 11:47'!
isDefinedByTemporary
	^ kind == 3! !

!ECTypeInfo methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 12:01'!
priority
	^kind! !

!ECTypeInfo methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 12:01'!
setType: aClass kind: anInteger 
	type := aClass.
	kind := anInteger! !

!ECTypeInfo methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 12:02'!
temporaryOffset
	^temporaryOffset! !

!ECTypeInfo methodsFor: 'as yet unclassified' stamp: 'lr 7/4/2009 10:42'!
temporaryOffset: anInteger 
	temporaryOffset := anInteger! !

!ECTypeInfo methodsFor: 'as yet unclassified' stamp: 'bar 12/2/2004 11:44'!
type
	^type! !

!ECTypeInfo methodsFor: 'as yet unclassified' stamp: 'lr 7/4/2009 10:42'!
type: aClass 
	type := aClass! !

Object subclass: #OCompletionTable
	instanceVariableNames: 'table numberofEntries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion'!

OCompletionTable class
	instanceVariableNames: 'table ctable'!

OCompletionTable class
	instanceVariableNames: 'table ctable'!

!OCompletionTable class methodsFor: 'as yet unclassified' stamp: 'rr 5/28/2009 11:14'!
classes
	^ ctable ifNil: [ctable := self new entriesPerPrefix: 40]! !

!OCompletionTable class methodsFor: 'as yet unclassified' stamp: 'rr 4/14/2009 17:13'!
default
	^ table ifNil: [table := self new entriesPerPrefix: 40]! !

!OCompletionTable class methodsFor: 'as yet unclassified' stamp: 'ul 11/6/2010 05:31'!
initialize

	SystemChangeNotifier uniqueInstance
		noMoreNotificationsFor: self; "avoid double registration"
		notify: self ofSystemChangesOfItem: #method using: #methodChanged:.
	self initializeTable.! !

!OCompletionTable class methodsFor: 'as yet unclassified' stamp: 'rr 4/28/2009 10:18'!
initializeTable
	self initializeWithInlinedMessages.
	self initializeWithPackages.
	self initializeWithRecentChanges.! !

!OCompletionTable class methodsFor: 'as yet unclassified' stamp: 'rr 4/28/2009 09:54'!
initializeWithInlinedMessages
	#(ifTrue: ifFalse: whileTrue: whileFalse: ifNil: ifNotNil: to:do: at:put: next: next size atEnd class value value: do: new: new) 
		do: [:e | self default addEntry: e].! !

!OCompletionTable class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/23/2010 10:17'!
initializeWithPackages
	| pkgs |
	pkgs := UIManager default request: '		Thanks for installing OCompletion!!
	
  OCompletion will be available in new browsers and workspaces you open.
	
  In order to be more accurate, OCompletion needs to know what you are working on. 
  If the packages you use or work on are already installed in the image, you can 
  specify them below, as a space-separated list of packages.
'
					initialAnswer: 'Kernel* Collection*'.
	pkgs ifNotNil: [
	(pkgs findTokens: ' ' ) do: [:e | self default quickFillWithCategoriesMatching: e ]]! !

!OCompletionTable class methodsFor: 'as yet unclassified' stamp: 'rr 4/16/2009 12:07'!
initializeWithRecentChanges
	ORecentChanges new readRecentChanges fillCompletionTable.! !

!OCompletionTable class methodsFor: 'as yet unclassified' stamp: 'ul 11/6/2010 06:23'!
lookForOB
	(Smalltalk at: #OBTextPanel ifAbsent: [^self]) compile: 'createCompletionController
	^(ECPreferences useECompletionInsteadOfOCompletion
		ifFalse: [ OController ]
		ifTrue: [ ECController ])
			model: self'! !

!OCompletionTable class methodsFor: 'as yet unclassified' stamp: 'rr 4/17/2009 15:00'!
methodChanged: event
	event isRemoved ifTrue: [^self].
	event isRecategorized ifTrue: [^self].
	self default totalNumberOfEntries < 200 ifTrue: [self default quickFillWithCategoryOf: event itemClass].
	self default totalNumberOfEntries < 500 ifTrue: [self default quickFillWithClass: event itemClass].
	self default justCompiled: event itemSelector in: event itemClass.! !

!OCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/9/2009 17:55'!
addEntry: aString 
	| d |
	d := DateAndTime now.
	self 
		addEntry: aString
		date: d! !

!OCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/15/2009 10:52'!
addEntry: aString date: d 
	| lists |
	lists := self listsForPrefix: aString.
	lists do: [:e | e
		addEntry: aString
		date: d] ! !

!OCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 5/11/2009 23:10'!
classesInCategory: category
	^ (Smalltalk organization listAtCategoryNamed: category) collect: [:className | Smalltalk at: className]! !

!OCompletionTable methodsFor: 'as yet unclassified' stamp: 'ul 11/6/2010 06:35'!
compiled: selector in: class date: date

	| method |
	self addEntry: selector date: date.
	self class classes addEntry: class theNonMetaClass name date: date.
	(class canUnderstand: selector) ifFalse: [ ^self ].
	method := class compiledMethodAt: selector ifAbsent: [ ^self ].
	method messages do: [ :m | self  addEntry: m date: date ].
	method literals do: [ :each |
		(each isVariableBinding and: [
			each key notNil and: [
				each key first isUppercase ] ])
					ifTrue: [ 
						self class classes addEntry: each key date: date ] ]! !

!OCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/17/2009 14:14'!
entriesMatching: prefix
	| list |
	
	list := self listForPrefix: prefix.
	^ list entriesMatching: prefix! !

!OCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/9/2009 17:42'!
entriesPerPrefix: n
	numberofEntries := n! !

!OCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/10/2009 12:11'!
fillRate
	^ self totalNumberOfEntries / self maxNumberOfEntries ! !

!OCompletionTable methodsFor: 'initialize-release' stamp: 'rr 4/9/2009 17:45'!
initialize
	table := Dictionary new.! !

!OCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/16/2009 12:01'!
justCompiled: selector in: class 
	| date |
	date := DateAndTime now.
	self 
		compiled: selector
		in: class
		date: date! !

!OCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/15/2009 10:55'!
listForPrefix: aString 
	| prefix |
	aString isEmpty ifTrue: [^ OEntryList ofSize: numberofEntries].
	prefix := aString size = 1 
			ifTrue: [ aString first asLowercase asString] 
			ifFalse: [(aString first: 2) collect: [:e | e asLowercase]].
			
	^ table 
		at: prefix
		ifAbsentPut: [ OEntryList ofSize: numberofEntries ]! !

!OCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/15/2009 10:56'!
listsForPrefix: aString 
	|  prefixes |
	aString isEmpty ifTrue: [^ Array with: (OEntryList ofSize: numberofEntries)].
	prefixes := OrderedCollection with: aString first asLowercase asString.
	 
	aString size > 1 
			ifTrue: [prefixes add: ((aString first: 2) collect: [:e | e asLowercase])].
	^ prefixes collect: [:prefix | table 
		at: prefix
		ifAbsentPut: [ OEntryList ofSize: numberofEntries ]]! !

!OCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/10/2009 12:10'!
maxNumberOfEntries
	^ 26 * 26 * numberofEntries ! !

!OCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/9/2009 17:46'!
numberOfEntries
	^ numberofEntries! !

!OCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 5/11/2009 23:11'!
quickFillWithCategoriesMatching: pattern
	(Smalltalk organization categoriesMatching: pattern) do: [:category | 
		(self classesInCategory: category) do: [:e | self quickFillWithClass: e]]! !

!OCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 5/11/2009 23:10'!
quickFillWithCategoryOf: cls
	(self classesInCategory: cls theNonMetaClass category) do: [:e | self quickFillWithClass: e]! !

!OCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 5/28/2009 14:10'!
quickFillWithClass: cls
	cls methodsDo: [:e | self justCompiled: e selector in: cls]
	! !

!OCompletionTable methodsFor: 'accessing' stamp: 'rr 4/10/2009 11:21'!
reset
	table := Dictionary new.! !

!OCompletionTable methodsFor: 'as yet unclassified' stamp: 'rr 4/9/2009 17:49'!
totalNumberOfEntries
	^ table inject: 0 into: [:total :list | total + list numEntries]! !

Object subclass: #OEmptyModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion'!

!OEmptyModel methodsFor: 'as yet unclassified' stamp: 'rr 4/14/2009 16:47'!
entries
	^ Array new! !

!OEmptyModel methodsFor: 'as yet unclassified' stamp: 'rr 4/17/2009 14:27'!
entryCount 
	^ 0! !

!OEmptyModel methodsFor: 'as yet unclassified' stamp: 'rr 4/17/2009 14:26'!
narrowString: string! !

!OEmptyModel methodsFor: 'as yet unclassified' stamp: 'rr 4/17/2009 14:26'!
narrowWith: string 
! !

Object subclass: #OEntryList
	instanceVariableNames: 'size entries entryHead'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion'!

!OEntryList class methodsFor: 'as yet unclassified' stamp: 'rr 2/21/2009 11:44'!
ofSize: n 
	^ self new setSize: n; yourself! !

!OEntryList methodsFor: 'adding' stamp: 'rr 4/9/2009 16:06'!
addEntry: aSymbol
	self addEntry: aSymbol date: DateAndTime now! !

!OEntryList methodsFor: 'adding' stamp: 'ul 12/6/2010 02:53'!
addEntry: aSymbol date: aDate

	| entry currentEntry |
	entry := entries at: aSymbol ifAbsent: nil.
	entry 
		ifNotNil: [ entry unlink ]
		ifNil: [ 
			entry := ODatedEntry contents: aSymbol type: #selector.
			entries at: aSymbol put: entry ].
	entry date: aDate.
	currentEntry := entryHead previous.
	[ currentEntry == entryHead or: [
		currentEntry date <= aDate ] ] whileFalse: [
			currentEntry := currentEntry previous ].
	currentEntry link: entry.
	entries size > size ifTrue: [
		entry := entryHead next unlink.
		entries removeKey: entry contents ]! !

!OEntryList methodsFor: 'accessing' stamp: 'ul 9/29/2010 18:56'!
entriesMatching: prefix
	
	^Array new: entries size // 4 + 1 streamContents: [ :stream |
		| entry |
		entry := self firstEntry.
		[ entry == entryHead ] whileFalse: [
			(entry matches: prefix) ifTrue: [ stream nextPut: entry ].
			entry := entry previous ] ]! !

!OEntryList methodsFor: 'accessing' stamp: 'rr 4/9/2009 16:14'!
first
	^self firstEntry contents! !

!OEntryList methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:31'!
firstEntry
	^ entryHead previous! !

!OEntryList methodsFor: 'accessing' stamp: 'rr 4/9/2009 16:14'!
last
	^self lastEntry contents! !

!OEntryList methodsFor: 'accessing' stamp: 'ul 9/27/2010 05:31'!
lastEntry
	^ entryHead next! !

!OEntryList methodsFor: 'accessing' stamp: 'rr 2/21/2009 11:46'!
numEntries
	^ entries size! !

!OEntryList methodsFor: 'as yet unclassified' stamp: 'ul 9/27/2010 05:25'!
setSize: n
	size := n.
	entries := Dictionary new: n.
	entryHead := ODatedEntry contents: #'' size type: #selector.
	entryHead
		next: entryHead;
		previous: entryHead.
	
	! !

Object subclass: #ORecentChanges
	instanceVariableNames: 'records'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion'!

!ORecentChanges methodsFor: 'as yet unclassified' stamp: 'rr 4/16/2009 11:56'!
fillCompletionTable
	records do: [:e | self fillCompletionTable: OCompletionTable default withRecord: e]! !

!ORecentChanges methodsFor: 'as yet unclassified' stamp: 'rr 4/16/2009 12:05'!
fillCompletionTable: table withRecord: r
	r methodClass ifNotNilDo: [:cls |
		table compiled: r methodSelector in: cls date: r timeStamp]! !

!ORecentChanges methodsFor: 'as yet unclassified' stamp: 'ul 10/29/2010 01:57'!
readRecentChanges
	| changeFile end changeList |
	changeFile := (SourceFiles at: 2) readOnlyCopy setConverterForCode.
	end := changeFile size.
	changeList := Cursor read showWhile: [
		ChangeList new
			scanFile: changeFile
			from: (0 max: end - 50000)
			to: end ].
	records := changeList changeList select: [:e | e type = #method].
	! !

!ParagraphEditor methodsFor: '*Ocompletion' stamp: 'bar 10/18/2004 07:09'!
caret
	^self startBlock stringIndex! !

!ParagraphEditor methodsFor: '*Ocompletion' stamp: 'bar 12/13/2004 15:28'!
isCaretBehindChar
	| pos |
	pos := self caret - 1.
	^ pos < 1
		ifTrue: [false]
		ifFalse: [(self text at: pos) isAlphaNumeric]! !

!ParagraphEditor methodsFor: '*Ocompletion' stamp: 'ul 10/29/2010 01:59'!
selectionPosition: aString

	| caret |
	caret := self caret.
	^[
		| bottomLeft topLeft |
		self selectAt: caret - aString size.
		bottomLeft := paragraph selectionRects first bottomLeft.
		topLeft := self morph owner submorphBounds topLeft.
		topLeft + bottomLeft ]
			ensure: [ self selectAt: caret ]! !

!ParagraphEditor methodsFor: '*Ocompletion' stamp: 'bar 12/18/2004 23:46'!
wordAtCaret
	^paragraph text asString wordBefore: self caret -1
! !

BorderedMorph subclass: #ECDetailMorph
	instanceVariableNames: 'title description arrowPosition label itemHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECView'!

!ECDetailMorph commentStamp: '<historical>' prior: 0!
I display some detail information for a selected ECEntry in the ECMenuMorph.
The content I show, is provided by an ECDetailContentProvider subclass. 
!

!ECDetailMorph class methodsFor: 'as yet unclassified' stamp: 'bar 3/3/2006 16:14'!
height
	^ ECMenuMorph itemHeight * 15.5! !

!ECDetailMorph class methodsFor: 'as yet unclassified' stamp: 'bar 3/3/2006 22:45'!
width
	^ ECMenuMorph itemWidth * 2.0! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'bar 3/3/2006 22:45'!
bounds
	^ super bounds topLeft extent: self class width @ self class height! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'DamienCassou 12/23/2009 16:25'!
contentBounds
	| factor rectangle |
	factor := ECMenuMorph messageHeight.
	rectangle := self bounds top: self bounds top + 3.
	rectangle := rectangle left: rectangle left + (factor * 2.0).
	rectangle := rectangle bottom: rectangle bottom - factor. 
	^ rectangle! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'bar 2/26/2006 11:48'!
defaultColor
	^ ECMenuMorph backgroundColor. ! !

!ECDetailMorph methodsFor: 'accessing' stamp: 'MAD 10/8/2009 14:19'!
descriptionBounds
	^ self contentBounds top: self contentBounds top + ECMenuMorph messageHeight + ECMenuMorph titleHeight ! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'MAD 10/8/2009 14:01'!
drawArrowOn: aCanvas 
	| point factor poligon |
	factor := self itemHeight.
	point := arrowPosition.
	poligon := OrderedCollection new.
	poligon add: point.
	poligon add: (point := point translateBy: factor / 2 @ 0).
	poligon add: (point := point translateBy: 0 @ (factor * -0.5)).
	poligon add: (point := point translateBy: factor @ factor).
	poligon add: (point := point translateBy: factor * -1 @ factor).
	poligon add: (point := point translateBy: 0 @ (factor * -0.5)).
	poligon add: (point := point translateBy: factor * -0.5 @ 0).
	aCanvas drawPolygon: poligon fillStyle: ECMenuMorph scrollColor! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'DamienCassou 12/23/2009 16:25'!
drawMessageOn: aCanvas 
	|  rectangle width browseMessage |
	rectangle := self bounds top: self bounds bottom - ECMenuMorph messageHeight.
	rectangle := rectangle left: self contentBounds left.
	aCanvas
		line: rectangle topLeft
		to: rectangle topRight - (1@0)
		color: Color gray.
	rectangle := rectangle insetBy: 1.
	aCanvas
		drawString: '<- close detail'
		in: rectangle
		font: ECMenuMorph messageFont
		color: Color gray.
	browseMessage := 'browse ->'.
	width := ECMenuMorph messageFont widthOfString: browseMessage .
	aCanvas
		drawString: browseMessage
		in: (rectangle left: rectangle right - width)
		font: ECMenuMorph messageFont
		color: Color gray! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'bar 3/2/2006 21:16'!
drawOn: aCanvas 
	super drawOn: aCanvas.
	arrowPosition ifNotNil: [
	self drawArrowOn: aCanvas.
	self drawMessageOn: aCanvas]! !

!ECDetailMorph methodsFor: 'accessing' stamp: 'bar 3/20/2006 15:33'!
entryDescription: anECEntryDescription 
	| categoryContents entryDescription |
	entryDescription := anECEntryDescription.
	title
		contents: (entryDescription title
				ifNil: [description bounds: self titleBounds.
					String new]
				ifNotNil: [description bounds: self descriptionBounds.
					entryDescription title]).
	description contentsWrapped: entryDescription description.
	categoryContents := entryDescription label.
	label contents: categoryContents! !

!ECDetailMorph methodsFor: 'accessing' stamp: 'DamienCassou 12/23/2009 16:25'!
initialize
	| childBounds |
	super initialize.
	self setBorderWidth: 1 borderColor: Color gray.
	childBounds := self contentBounds.
	label := StringMorph contents: '' font: ECMenuMorph messageFont.
	label bounds: childBounds.
	self addMorph: label.
	title := StringMorph contents: '' font: ECMenuMorph titleFont.
	title bounds: self titleBounds.
	self addMorph: title.
	description := TextMorph new.
	description autoFit: false.
	description bounds: self descriptionBounds.
	description borderWidth: 0.
	self addMorph: description! !

!ECDetailMorph methodsFor: 'accessing' stamp: 'MAD 10/8/2009 14:00'!
itemHeight
	^ itemHeight ifNil: [itemHeight := ECMenuMorph itemHeight]! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'MAD 10/8/2009 14:01'!
position: aPoint menuWidth: anInteger 
	| y x |
	arrowPosition := aPoint.
	y := aPoint y + self class height.
	y := y > Display height
				ifTrue: [Display height - self class height]
				ifFalse: [aPoint y - self itemHeight].
	x := aPoint x.
	x := x + self class width > Display width
				ifTrue: [arrowPosition := (self positionOnLeft: anInteger) @ aPoint y.
					arrowPosition x]
				ifFalse: [x].
	self position: x @ y! !

!ECDetailMorph methodsFor: 'private' stamp: 'MAD 10/8/2009 11:05'!
positionOnLeft: anInteger 
	"tightened up the positioning. MAD"
	^ arrowPosition x - self class width - anInteger + 2! !

!ECDetailMorph methodsFor: 'accessing' stamp: 'MAD 10/8/2009 14:16'!
titleBounds
	^ self contentBounds top: self contentBounds top + ECMenuMorph messageHeight! !

BorderedMorph subclass: #ECMenuMorph
	instanceVariableNames: 'selected firstVisible titleStringMorph controller context pageHeight itemHeight detailMorph detailPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECView'!

ECMenuMorph class
	instanceVariableNames: 'messageFont titleFont'!

!ECMenuMorph commentStamp: '<historical>' prior: 0!
I show the possible completions in a menu like appearance. The user may choose an entry from my list and complete the word he was typing in the editor. I'm showed with the Tab key and will be deleted when with ESC key or when a successful completion occurs. The following keystrokes are supported:

Ctrl-Space or Tab: Open a new morph. Tab requires at least one character in front of the cursor. When already open complete the selected entry. 
Esc: Close me
Ctrl+u: Change to untyped mode, so I show all selectors of all classes in the system and the variables that are accessible to the current context.
Arrow Up: Move one entry up.
Arrow Down: Move one entry down
Enter: (like Ctrl-Space and Tab): Complete with the selected item and close the morph
any letter or digit: Narrow the completion further
Ctrl+t: Toggle the expand flag. When expand is disabled, you don't see selectors belonging to Object and ProtoObject. 

!

ECMenuMorph class
	instanceVariableNames: 'messageFont titleFont'!

!ECMenuMorph class methodsFor: 'preferences' stamp: 'RomainRobbes 10/19/2009 19:26'!
backgroundColor
	"ECMenuMorph backgroundColor"
	^ Color gray: 0.95! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'MAD 10/8/2009 10:57'!
borderColor
	^ Color gray! !

!ECMenuMorph class methodsFor: 'instance creation' stamp: 'bar 12/13/2004 11:34'!
controller: aECController position: aPoint 
	| newObject |
	newObject := self new.
	newObject setController: aECController position: aPoint.
	^ newObject! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'MAD 10/7/2009 12:17'!
convertToSHSymbol: aSymbol 
	^ (SHTextStylerST80 new attributesFor: aSymbol)
			isNil
				ifTrue: [#default]
				ifFalse: [aSymbol]
! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'lr 7/4/2009 10:42'!
helpText
	| text |
	text := TextStream new.
	text 
		withAttribute: TextEmphasis bold
		do: [ text nextPut: 'hello' ] text! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'MAD 10/8/2009 14:04'!
itemHeight
	"height must be forced to be even to allow the detail arrow to be drawn correctly"	
	^ (self listFont height + 2) roundUpTo: 2"14".! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'MAD 10/8/2009 11:40'!
itemWidth

	^ ECMenuMorph listFont widthOfString:'SphinxOfBlackQuartzHearMyVow1234567890' "212."! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'ul 10/27/2010 03:13'!
listFont

	^ECPreferences listFont! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'bar 10/17/2004 15:16'!
maxLength

	"CompletionMorph maxLength "
	
	^30.! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'MAD 10/7/2009 12:01'!
messageFont
	"hard code a strike font for tidiness"
	^ StrikeFont familyName: 'Accujen' pointSize: 10 emphasized: 0.
! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'MAD 10/8/2009 13:49'!
messageHeight
	^ self messageFont height + 2! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'bar 11/19/2004 20:53'!
scrollArrowSize
	^8! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'ul 10/27/2010 03:16'!
scrollColor

	^ECPreferences menuSelectionColor ! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'lr 7/4/2009 10:42'!
selectColorFor: aSymbol 
	| attribute |
	attribute := self convertToSHSymbol: aSymbol.
	^ (SHTextStylerST80 new attributesFor: attribute) first color! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'DamienCassou 12/23/2009 16:25'!
selectFontFor: aSymbol 
	| emphasized attributes |
	attributes := SHTextStylerST80 new
				attributesFor: (self convertToSHSymbol: aSymbol).
	emphasized := attributes size > 1
				ifTrue: [attributes second emphasisCode]
				ifFalse: [0]. 
	^ self listFont emphasized: emphasized! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'MAD 10/7/2009 11:48'!
titleFont
	"use a strikefont, as TT fonts don't rotate nicely. Don't cache, as it gets manipulated later"
	^ StrikeFont familyName: 'Accujen' pointSize: 12 emphasized: 1! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'MAD 10/8/2009 14:19'!
titleHeight
	^ self titleFont height + 2! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 3/3/2006 16:28'!
browse
	(self selectedEntry browseWith: context)
		ifTrue: [controller closeMenu]! !

!ECMenuMorph methodsFor: 'initialization' stamp: 'MAD 10/8/2009 14:06'!
createTitle
	| transformationMorph titleString |
	titleString := context model title.
	titleString
		ifNil: [^ self].
	transformationMorph := TransformationMorph new.
	self addMorph: transformationMorph.
	titleStringMorph := StringMorph new.
	titleStringMorph font: self class titleFont.
	transformationMorph addMorph: titleStringMorph.
	transformationMorph rotationDegrees: -90.0.
	titleStringMorph contents: titleString.
	transformationMorph topLeft: (self topLeft + (0@12))! !

!ECMenuMorph methodsFor: 'paging' stamp: 'bar 2/21/2006 21:32'!
currentPage
	^(self selected - 1 // self pageHeight ) + 1.! !

!ECMenuMorph methodsFor: 'private' stamp: 'bar 12/13/2004 13:41'!
delete
	super delete.
	controller menuClosed! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'MAD 10/7/2009 12:39'!
detailMessage
	^ detailMorph
		ifNil: [self helpText, ' | -> open detail']
		ifNotNil: [self helpText, ' | <- close detail']! !

!ECMenuMorph methodsFor: 'accessing' stamp: 'bar 3/12/2006 10:46'!
detailPosition: aPoint 
	detailPosition := aPoint.
	self triggerEvent: #positionChanged! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'lr 7/4/2009 10:42'!
drawBottomScrollArrowOn: aCanvas 
	| aPoligon point arrowHeight |
	point := self bounds bottomLeft translateBy: 6 @ -12.
	arrowHeight := self class scrollArrowSize.
	aPoligon := Array 
		with: point
		with: (point translateBy: arrowHeight @ 0)
		with: (point translateBy: (arrowHeight / 2) @ arrowHeight).
	aCanvas 
		drawPolygon: aPoligon
		fillStyle: self class scrollColor! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'MAD 10/8/2009 14:07'!
drawMessageOn: aCanvas in: rectangle 
	self hasMessage ifFalse:[^self].
	context model isEmpty 
		ifFalse:[
			aCanvas
				line: rectangle topLeft + (0 @ 1)
				to: rectangle topRight + (0 @ 1)
				color: Color gray]. 
	self drawModelMessageOn: aCanvas in:rectangle.
	self drawPageCountMessageOn: aCanvas in: rectangle.! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'DamienCassou 12/23/2009 16:25'!
drawModelMessageOn: aCanvas in: rectangle 
	| message |
	message := context model hasMessage
				ifTrue: [context model message, ' | ', self helpText]
				ifFalse: [self detailMessage].
	aCanvas
		drawString: message
		in: (rectangle insetBy: 1)
		font: self class messageFont
		color: Color gray! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'DamienCassou 12/23/2009 16:25'!
drawOn: aCanvas 
	| rectangle model textColor |
	super drawOn: aCanvas.
	self drawTitleOn: aCanvas.
	rectangle := self bounds copy.
	rectangle bottom: rectangle top + self itemHeight.
	rectangle := rectangle left: rectangle left + 20.
	model := context model.
	self extent: self extent.
	self firstVisible > 1
		ifTrue: [self drawTopScrollArrowOn: aCanvas].
	self lastVisible ~= self itemsCount
		ifTrue: [self drawBottomScrollArrowOn: aCanvas].
	model notEmpty
		ifTrue: [self firstVisible
				to: self lastVisible
				do: [:index | 
					| symbol type string | 
					symbol := model entries at: index.
					string := symbol contents.
					type := symbol type.
					textColor := self selectColor: type.
					index = self selected
						ifTrue: [| rect | 
							rect := rectangle withBottom: rectangle top + self class itemHeight.
							aCanvas fillRectangle: rect color: self class scrollColor.
							self detailPosition: rect topRight - (1@0).
							textColor := textColor negated ].
					aCanvas
						drawString: string
						in: (rectangle insetBy: 1)
						font: (self selectFont: type)
						color: textColor.
					rectangle := self prepareRectForNextRow: rectangle]].
	"tweak rectangle to display message"
	rectangle := rectangle top: (self bounds bottom - self class messageHeight).
	self drawMessageOn: aCanvas in: rectangle! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'DamienCassou 12/23/2009 16:25'!
drawPageCountMessageOn: aCanvas in: rectangle 
	| msg font msgWidth |
	self pageCount > 1 ifFalse:[^self].
	msg :=  self currentPage printString, '/', self pageCountString.
	font := self class messageFont.
	msgWidth := font widthOfString: msg.
	aCanvas 
		drawString: msg 
		in: (rectangle translateBy: (rectangle width - msgWidth - 3) @ 1)
		font: font
		color: Color gray. 
		! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 11/25/2004 09:48'!
drawTitleOn: aCanvas
	"| morphicTransform angle |
	angle := 90 degreesToRadians.
	morphicTransform := MorphicTransform offset: self position angle: angle scale: 1.0.
	aCanvas 
		transformBy: morphicTransform
		clippingTo: self owner innerBounds
		during: [:myCanvas | myCanvas drawString:'Ruben' at: self position font: self class titleFont color: Color blue]
		smoothing: 1."
		! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 11/19/2004 20:54'!
drawTopScrollArrowOn: aCanvas 
	| aPoligon point arrowHeight |
	arrowHeight := self class scrollArrowSize.
	point := self bounds topLeft translateBy: 6 @ 11.
	aPoligon := Array 
				with: point
				with: (point translateBy: arrowHeight @ 0)
				with: (point translateBy: arrowHeight / 2 @ arrowHeight negated).
	aCanvas 
		drawPolygon: aPoligon 
		fillStyle: self class scrollColor. 
	! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 2/20/2006 17:26'!
end
	self gotoPage: self pageCount.
	self changed.! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 12/16/2004 11:36'!
expand
	context model toggleExpand.
	self narrowCompletion! !

!ECMenuMorph methodsFor: 'private' stamp: 'bar 12/13/2004 11:46'!
firstVisible
	^firstVisible min: context model entryCount! !

!ECMenuMorph methodsFor: 'paging' stamp: 'bar 3/20/2006 16:05'!
gotoPage: anInteger
	| item |
	item := ((anInteger - 1) * self pageHeight) + 1. 
	item >= self itemsCount ifTrue:[^self].
	item < 1 ifTrue:[item := 1].
	firstVisible := item.
	self selected: firstVisible. 
	! !

!ECMenuMorph methodsFor: 'event handling' stamp: 'bar 3/31/2006 16:07'!
handleMouseEnter: anEvent
	self activeHand newKeyboardFocus: controller editor morph.
	anEvent wasHandled: true. 
! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 3/12/2006 14:47'!
hasMessage
	^ true ! !

!ECMenuMorph methodsFor: 'accessing' stamp: 'DamienCassou 12/23/2009 16:25'!
height
	| height |
	height := self visible
				ifTrue: [Display height - self bounds topLeft y / self itemHeight - 1 min: self class maxLength]
				ifFalse: [self class maxLength].
	height asInteger isZero
		ifTrue: [^ 1]
		ifFalse: [^ height].! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 3/12/2006 14:37'!
help
	ECHelpMorph new openInWorld! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'MAD 10/7/2009 12:39'!
helpText
	^ '?=help'! !

!ECMenuMorph methodsFor: 'actions' stamp: 'lr 7/4/2009 10:42'!
hideDetail
	detailMorph ifNil: [ ^ self ].
	self removeMorph: detailMorph.
	detailMorph delete.
	detailMorph := nil.
	self changed! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 2/20/2006 17:26'!
home
	self gotoPage: 1.
	self changed! !

!ECMenuMorph methodsFor: 'initialization' stamp: 'MAD 10/8/2009 10:58'!
initialize
	super initialize.
	self color: self class backgroundColor.
	self setBorderWidth: 1 borderColor: self class borderColor.
	self
		when: #positionChanged
		send: #updateDetail
		to: self! !

!ECMenuMorph methodsFor: 'actions' stamp: 'ul 10/13/2010 23:27'!
insertCompletion: aString 
	| caret oldSelectionInterval editor |
	editor := controller editor.
	caret := editor caret.
	oldSelectionInterval := caret - context completionToken size to: caret - 1.
	editor 
		replace: oldSelectionInterval
		with: aString
		and: [ 
			editor selectAt: caret + (aString copyUpTo: $ ) size + 1 - oldSelectionInterval size ].
	editor morph invalidRect: editor morph bounds! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 3/3/2006 16:30'!
insertSelected
	context model isEmpty ifTrue: [^ false].
	self insertCompletion: (context model completionAt: self selected).
	self delete.
	^ true! !

!ECMenuMorph methodsFor: 'private' stamp: 'bar 12/13/2004 16:14'!
isClosed
	^ owner isNil! !

!ECMenuMorph methodsFor: 'accessing' stamp: 'MAD 10/8/2009 14:03'!
itemHeight
	"cached to minimise recalculation"
	^ itemHeight ifNil: [itemHeight := self class itemHeight]! !

!ECMenuMorph methodsFor: 'private' stamp: 'bar 12/13/2004 11:47'!
itemsCount
	^context model entryCount! !

!ECMenuMorph methodsFor: 'private' stamp: 'RomainRobbes 8/2/2010 17:57'!
lastVisible

	^ (self firstVisible + self height - 1)  min: (self itemsCount).! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 12/5/2004 22:23'!
moveDown
	self selected: self selected + 1.
	(self selected > self lastVisible
			and: [self selected <= self itemsCount])
		ifTrue: [firstVisible := firstVisible + 1].
	self changed! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 12/13/2004 15:05'!
moveUp
	(self selected = 0
			and: [self firstVisible = 1])
		ifTrue: [^ self].
	self selected: self selected - 1.
	self selected < self firstVisible
		ifTrue: [firstVisible := firstVisible - 1].
	self changed. ! !

!ECMenuMorph methodsFor: 'actions' stamp: 'lr 7/4/2009 10:42'!
narrowCompletion
	| model |
	self selected: 0.
	firstVisible := 1.
	model := context model.
	model narrowWith: context completionToken.
	(model entries size = 1 and: [ context completionToken notEmpty ]) ifTrue: 
		[ self insertCompletion: (model completionAt: 1).
		self delete.
		^ false ].
	model notEmpty ifTrue: [ self selected: 1 ].
	self show.
	^ true! !

!ECMenuMorph methodsFor: 'paging' stamp: 'bar 3/30/2006 14:21'!
pageCount
	| count |
	self itemsCount == self pageHeight
		ifTrue: [^ 1].
	count := self itemsCount // self pageHeight.
	(self itemsCount \\ self pageHeight) > 0 
		ifTrue:[count := count + 1].
	^count! !

!ECMenuMorph methodsFor: 'paging' stamp: 'cmm 1/8/2007 21:09'!
pageCountString
	^ self itemsCount = 501
		ifTrue: [ 'more' ]
		ifFalse: [ self pageCount asString ]! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 2/20/2006 17:24'!
pageDown
	self gotoPage: self currentPage + 1.
	self changed. ! !

!ECMenuMorph methodsFor: 'paging' stamp: 'bar 2/20/2006 17:53'!
pageHeight
	^pageHeight.! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 2/20/2006 17:26'!
pageUp
	self gotoPage: self currentPage - 1.
	self changed. ! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'MAD 10/8/2009 14:02'!
prepareRectForNextRow: aRectangle 
	^aRectangle translateBy: 0 @ self itemHeight! !

!ECMenuMorph methodsFor: 'title' stamp: 'bar 12/13/2004 14:16'!
removeTitle
	titleStringMorph
		ifNil: [^ self].
	self removeMorph: titleStringMorph owner. 
	titleStringMorph := nil! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 8/12/2005 23:12'!
selectColor: type
	^ self class selectColorFor: type! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 8/12/2005 22:43'!
selectFont: aSymbol 
	^ self class selectFontFor: aSymbol! !

!ECMenuMorph methodsFor: 'accessing' stamp: 'lr 7/4/2009 10:42'!
selected
	"Answer the value of selected"
	selected ifNil: [ selected := self firstVisible ].
	^ selected! !

!ECMenuMorph methodsFor: 'accessing' stamp: 'lr 7/4/2009 10:42'!
selected: aNumber 
	"Set the value of selected"
	context model notEmpty ifTrue: 
		[ ((1 to: self itemsCount) includes: aNumber) ifTrue: [ aNumber ~= selected ifTrue: [ selected := aNumber ] ] ]! !

!ECMenuMorph methodsFor: 'accessing' stamp: 'bar 3/3/2006 16:30'!
selectedEntry
	^ context model entries at: self selected! !

!ECMenuMorph methodsFor: 'initialization' stamp: 'bar 3/31/2006 09:34'!
setController: aECController position: aPoint 
	controller := aECController.
	context := controller context.
	self createTitle.
	self position: aPoint - (20 @ 0).
	self narrowCompletion
		ifTrue: [self openInWorld]. 
! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'DamienCassou 12/23/2009 16:25'!
show
	| extent height |
	firstVisible := 1.
	height := self visibleItemsCount * self itemHeight.
	pageHeight := self height asInteger.
	self hasMessage
		ifTrue: [height := height + self class itemHeight].
	titleStringMorph
		ifNotNil: [height := height max: titleStringMorph width + 30].
	extent := self class itemWidth @ height.
	self extent: extent.
	self changed! !

!ECMenuMorph methodsFor: 'actions' stamp: 'lr 7/4/2009 10:42'!
showDetail
	detailMorph ifNotNil: [ ^ self browse ].
	self itemsCount isZero ifTrue: [ ^ self ].
	detailMorph := ECDetailMorph new.
	self addMorph: detailMorph.
	self updateDetail! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 12/20/2004 23:21'!
switchToUntyped
	context switchToUntyped.
	self removeTitle; narrowCompletion; changed! !

!ECMenuMorph methodsFor: 'private' stamp: 'bar 3/3/2006 22:52'!
updateDetail
	detailMorph
		ifNil: [^ self].
	detailMorph
		entryDescription: (self selectedEntry descriptionWith: context).
	detailMorph position: detailPosition menuWidth: self width.
	detailMorph show! !

!ECMenuMorph methodsFor: 'private' stamp: 'pk 6/3/2004 16:31'!
visibleItemsCount.

	^ self lastVisible - self firstVisible + 1! !

ECMenuMorph subclass: #OMenuMorph
	instanceVariableNames: 'lastActivity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion'!

!OMenuMorph class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 10/19/2009 19:24'!
backgroundColor
	"ECMenuMorph backgroundColor"
	^ (Color gray: 0.9) alpha: 0.8! !

!OMenuMorph class methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 10/19/2009 19:36'!
itemWidth

	^ ECMenuMorph listFont widthOfString:'SphinxOfBlackQuartzHearMyVow' "212."! !

!OMenuMorph class methodsFor: 'as yet unclassified' stamp: 'ul 10/27/2010 03:10'!
scrollColor

	^super scrollColor alpha: 0.8! !

!OMenuMorph class methodsFor: 'as yet unclassified' stamp: 'ul 10/27/2010 03:15'!
selectFontFor: aSymbol 
	| emphasized attributes |
	attributes := SHTextStylerST80 new
				attributesFor: (self convertToSHSymbol: aSymbol).
	emphasized := attributes size > 1
				ifTrue: [attributes second emphasisCode]
				ifFalse: [0]. 
	^ECPreferences menuFont 
		emphasized: emphasized! !

!OMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 4/15/2009 15:23'!
context
	^ context! !

!OMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 4/15/2009 15:24'!
context: ctx
	context := ctx.! !

!OMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 12/11/2007 09:41'!
createTitle! !

!OMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 12:15'!
drawOn: aCanvas 
	| rectangle model textColor |
	context model isEmpty ifTrue: [^self].
	
	"super drawOn: aCanvas."
	rectangle := self bounds copy.
	rectangle bottom: rectangle top + self class itemHeight.
	rectangle := rectangle left: rectangle left + 20.
	aCanvas fillRectangle: rectangle fillStyle: self fillStyle borderStyle: self borderStyle.
	model := context model.
	self extent: self extent.
	self firstVisible > 1
		ifTrue: [self drawTopScrollArrowOn: aCanvas].
	self lastVisible ~= self itemsCount
		ifTrue: [self drawBottomScrollArrowOn: aCanvas].
	model notEmpty
		ifTrue: [self firstVisible
				to: self lastVisible
				do: [:index | 
					| symbol type string | 
					symbol := model entries at: index.
					string := symbol contents.
					type := symbol type.
					textColor := self selectColor: type.
					index = self selected
						ifTrue: [| rect | 
							rect := rectangle withBottom: rectangle top + self class itemHeight.
							aCanvas fillRectangle: rect color: self class scrollColor.
							self detailPosition: rect topRight.
							textColor := Color white ].
					aCanvas
						drawString: string
						in: (rectangle insetBy: 1)
						font: (self selectFont: type)
						color: textColor.
					rectangle := self prepareRectForNextRow: rectangle]].
	self drawMessageOn: aCanvas in: rectangle! !

!OMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 12/11/2007 09:44'!
drawTopScrollArrowOn: aCanvas 
	! !

!OMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 12/11/2007 09:39'!
hasMessage
	^ false! !

!OMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 8/2/2010 17:55'!
height
	^ 4! !

!OMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 12:19'!
initialize 
	super initialize.
	self on: #mouseDown send: #delete to: self.
	self startStepping! !

!OMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 12:08'!
lastActivity 
	lastActivity ifNil: [self stillActive].
	^ lastActivity ! !

!OMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 6/26/2009 11:09'!
narrowCompletion
	| model |
	self selected: 0.
	firstVisible := 1.
	model := context model.
	model narrowWith: context completionToken.
	"(model entries size = 1 and: [context completionToken notEmpty]) 
		ifTrue: 
			[self insertCompletion: (model completionAt: 1).
			self delete.
			^ false]."
	model notEmpty ifTrue: [self selected: 1].
	self show.
	^ true! !

!OMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:41'!
step
	self timeOfLastActivity > self timeout
		ifTrue: [ self delete ]
		ifFalse: [self updateColor]! !

!OMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:48'!
stepTime 
	^ 100! !

!OMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:50'!
stillActive
	lastActivity := Time millisecondClockValue.! !

!OMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:52'!
timeOfLastActivity
	^ (Time millisecondClockValue - self lastActivity)   ! !

!OMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:41'!
timeout
	^ 5000! !

!OMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 18:00'!
updateColor
	| remaining alpha |
	remaining := (self timeout - self timeOfLastActivity).
	remaining < 1000 
		ifTrue: [
			alpha := remaining / 1000.0.
			self color: (self color alpha: alpha).
			self borderColor: (self borderColor alpha: alpha)
			]! !

ECMenuMorph subclass: #OXMenuMorph
	instanceVariableNames: 'lastActivity'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion'!

!OXMenuMorph class methodsFor: 'as yet unclassified' stamp: 'ul 10/27/2010 03:10'!
scrollColor

	^super scrollColor alpha: 0.8! !

!OXMenuMorph class methodsFor: 'as yet unclassified' stamp: 'ul 10/27/2010 03:15'!
selectFontFor: aSymbol 
	| emphasized attributes |
	attributes := SHTextStylerST80 new
				attributesFor: (self convertToSHSymbol: aSymbol).
	emphasized := attributes size > 1
				ifTrue: [attributes second emphasisCode]
				ifFalse: [0]. 
	^ECPreferences menuFont 
		emphasized: emphasized! !

!OXMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 4/15/2009 15:23'!
context
	^ context! !

!OXMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 4/15/2009 15:23'!
context: ctx
	context := ctx.! !

!OXMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 12/11/2007 10:15'!
delete
	super delete.
	controller retract! !

!OXMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 12/11/2007 09:45'!
hasMessage
	^ false! !

!OXMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 4/15/2009 15:32'!
height
	^ 7! !

!OXMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 12:21'!
initialize 
	super initialize.
	self on: #mouseDown send: #delete to: self.
	self startStepping ! !

!OXMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 12/11/2007 10:14'!
insertCompletion: aString
	super insertCompletion: aString.
	controller retract! !

!OXMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 12:20'!
lastActivity 
	lastActivity ifNil: [self stillActive].
	^ lastActivity ! !

!OXMenuMorph methodsFor: 'as yet unclassified' stamp: 'rr 6/26/2009 11:33'!
narrowCompletion
	| model |
	
	self selected: 0.
	firstVisible := 1.
	model := context model.
	model narrowWith: context completionToken.
	model notEmpty ifTrue: [self selected: 1].
	model entries size < self selected ifTrue: [self selected: model entries size].
	self show.
	^ true! !

!OXMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:59'!
step
	self timeOfLastActivity > self timeout
		ifTrue: [ self delete ]
		ifFalse: [self updateColor]! !

!OXMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:56'!
stepTime 
	^ 100! !

!OXMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:55'!
stillActive
	lastActivity := Time millisecondClockValue.! !

!OXMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:55'!
timeOfLastActivity
	^ (Time millisecondClockValue - self lastActivity)   ! !

!OXMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 17:55'!
timeout
	^ 5000! !

!OXMenuMorph methodsFor: 'as yet unclassified' stamp: 'RomainRobbes 4/8/2010 18:00'!
updateColor
	| remaining alpha |
	remaining := (self timeout - self timeOfLastActivity).
	
	remaining < 1000 
		ifTrue: [
			alpha := remaining / 1000.0.
			self color: (self color alpha: alpha).
			self borderColor: (self borderColor alpha: alpha)
			]! !

!Symbol methodsFor: '*Ocompletion' stamp: 'ul 10/29/2010 02:23'!
separateKeywords

	^self isKeyword
		ifFalse: [ self ]
		ifTrue: [ self copyReplaceAll: ':' with: ':  ' ]
! !

!SHRange methodsFor: '*Ocompletion' stamp: 'ul 9/29/2010 19:11'!
asType
	type = #symbol
		ifTrue: [^ Symbol].
	type = #character
		ifTrue: [^ Character].
	type = #string
		ifTrue: [^ String].
	type = #number
		ifTrue: [^ Number].
	type = #true
		ifTrue: [^ Smalltalk at: #True].
	type = #false
		ifTrue: [^ Smalltalk at: #False].
	type = #arrayEnd
		ifTrue: [^ Array].
	self isBlockEnd
		ifTrue: [^ BlockClosure].
	^ nil! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 1/6/2005 22:08'!
includesPosition: aNumber
^(start <= aNumber
					and: [end >= aNumber])! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 1/9/2005 13:14'!
isArgument
	^ type = #methodArg! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 1/9/2005 14:51'!
isAssignment
	^#(#assignment #ansiAssignment ) includes: type! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 3/2/2006 21:27'!
isBinary
	^type == #binary! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 1/6/2005 22:22'!
isBlockEnd
	^ type beginsWith: 'blockEnd'! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 1/6/2005 22:21'!
isBlockStart
	^type beginsWith: 'blockStart'! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 9/20/2006 08:29'!
isBlockTemporary
	^#(#blockPatternTempVar #blockPatternArg) includes: type! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 8/9/2005 23:04'!
isClassVariable
	^ type = #classVar! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 1/6/2005 13:17'!
isComment
	^ type == #comment! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 1/9/2005 13:20'!
isConstant
	^ self isBlockEnd
		or: [#(#false #true #string #number #symbol #character #arrayEnd ) includes: type]! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 1/9/2005 13:06'!
isGlobal
	^type = #globalVar! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 1/9/2005 13:13'!
isInstanceVariable
	^ type = #instVar! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 3/9/2006 10:10'!
isKeyword
	^ type == #keyword or:[type == #undefinedKeyword]! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 1/6/2005 13:56'!
isOpening
^ ((type beginsWith: 'blockStart')
			or: [type beginsWith: 'leftParenthesis'])
		! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 1/9/2005 13:05'!
isSelf
	^type = #self! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 1/9/2005 14:37'!
isSeparator
	^ #(#methodTempBar #statementSeparator #patternUnary #patternArg #blockPatternArg #blockArgsBar #return #primitiveOrExternalCallEnd) includes: type! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 1/9/2005 13:05'!
isSuper
	^type = #super! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 1/9/2005 13:03'!
isTemporaryVariable
	^ #(#tempVar #blockTempVar workspaceVar ) includes: type! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 1/6/2005 13:18'!
isUnfinished
	^#(#unfinishedString #unfinishedComment ) includes: type! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 1/9/2005 13:13'!
isVariable
	^ self isTemporaryVariable
		or: [self isInstanceVariable
				or: [self isSelf or:[self isSuper]]]! !

!SHRange methodsFor: '*Ocompletion' stamp: 'bar 3/2/2006 21:26'!
isVariablesOnly
	^ self isAssignment
		or: [self isVariable
				or: [self isConstant
						or: [self isSeparator or:[self isBinary]]]]! !

InstructionClient subclass: #ECVarTypeGuesser
	instanceVariableNames: 'types receiverClass variableName found currentMethod hasSend contextCount'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECVarTypeGuesser commentStamp: '<historical>' prior: 0!
I'm an InstructionClient that tries to guess the type of a given instance variable name of a class. !

ECVarTypeGuesser subclass: #ECClassVarTypeGuesser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECClassVarTypeGuesser methodsFor: 'as yet unclassified' stamp: 'lr 7/4/2009 10:42'!
methodRefs
	| theClass classVarAssoc |
	theClass := receiverClass classThatDefinesClassVariable: variableName.
	classVarAssoc := theClass classPool associationAt: variableName asSymbol.
	classVarAssoc value 
		ifNil: [ ^ SystemNavigation new allCallsOn: classVarAssoc ]
		ifNotNil: [ ^ classVarAssoc value class ]! !

!ECClassVarTypeGuesser methodsFor: 'as yet unclassified' stamp: 'lr 7/4/2009 10:42'!
popIntoLiteralVariable: anAssociation 
	anAssociation key == variableName asSymbol 
		ifTrue: [ found := true ]
		ifFalse: [ self reset ]! !

!ECClassVarTypeGuesser methodsFor: 'as yet unclassified' stamp: 'bar 8/11/2005 13:07'!
popIntoReceiverVariable: offset 
	self reset! !

!ECClassVarTypeGuesser methodsFor: 'as yet unclassified' stamp: 'bar 8/11/2005 13:14'!
send: selector super: supered numArgs: numberArguments 
! !

ECVarTypeGuesser subclass: #ECInstVarTypeGuesser
	instanceVariableNames: 'varIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECModel'!

!ECInstVarTypeGuesser commentStamp: '<historical>' prior: 0!
I'm a simple InstructionClient that tries to guess the type of a given instance variable name of a class. !

!ECInstVarTypeGuesser methodsFor: 'as yet unclassified' stamp: 'lr 9/26/2010 17:44'!
methodRefs
	| theClass selectors |
	theClass := receiverClass classThatDefinesInstanceVariable: variableName.
	theClass ifNil: [ ^ nil ].
	selectors := theClass whichSelectorsStoreInto: variableName.
	^ selectors collect: [ :each | MethodReference new setStandardClass: theClass methodSymbol: each ]! !

!ECInstVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'lr 7/4/2009 10:42'!
popIntoReceiverVariable: offset 
	varIndex = offset 
		ifTrue: [ found := true ]
		ifFalse: [ self reset ]! !

!ECInstVarTypeGuesser methodsFor: 'as yet unclassified' stamp: 'lr 7/4/2009 10:42'!
prepare: aCompiledMethod 
	| theClass |
	super prepare: aCompiledMethod.
	theClass := aCompiledMethod actualClass.
	varIndex := (theClass allInstVarNames indexOf: variableName) - 1! !

!ECVarTypeGuesser class methodsFor: 'as yet unclassified' stamp: 'bar 12/9/2004 18:37'!
getClassFromTypeSuggestingName: aString 
	| firstUppercaseLetter className aStream aClass |
	aStream := WriteStream on: String new.
	aStream nextPut: aString first asUppercase.
	aStream
		nextPutAll: (aString copyFrom: 2 to: aString size).
	className := aStream contents.
	aClass := Smalltalk
				at: className asSymbol
				ifAbsent: [].
	(aClass isKindOf: Class)
		ifTrue: [^ aClass].
	firstUppercaseLetter := aString indexOfFirstUppercaseCharacter.
	className := firstUppercaseLetter > 1
				ifTrue: [aString copyFrom: firstUppercaseLetter to: aString size]
				ifFalse: [^ nil].
	aClass := Smalltalk
				at: className asSymbol
				ifAbsent: [].
	(aClass isKindOf: Class)
		ifTrue: [^ aClass].
	^ nil! !

!ECVarTypeGuesser class methodsFor: 'as yet unclassified' stamp: 'bar 12/8/2004 13:47'!
variableName: aString class: aClass 
	^self variableName: aString source: nil class: aClass ! !

!ECVarTypeGuesser class methodsFor: 'as yet unclassified' stamp: 'lr 7/4/2009 10:42'!
variableName: aString source: sourceString class: aClass 
	| newInstance |
	newInstance := self basicNew initialize.
	newInstance 
		setVariableName: aString
		source: sourceString
		class: aClass.
	^ newInstance! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'lr 7/4/2009 10:42'!
blockReturnTop
	contextCount := contextCount - 1! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'lr 7/4/2009 10:42'!
computeVarType
	| info tempNames name |
	types ifEmpty: [ ^ nil ].
	info := types first.
	(hasSend and: [ info isDefinedByMessageSend not ]) ifTrue: 
		[ info type: nil.
		^ info ].
	info isDefinedByTemporary not ifTrue: [ ^ info ].
	tempNames := (receiverClass compilerClass new 
		parse: currentMethod getSourceFromFile asString
		in: receiverClass
		notifying: nil) tempNames.
	name := tempNames at: info temporaryOffset + 1.
	info type: (self class getClassFromTypeSuggestingName: name).
	^ info! !

!ECVarTypeGuesser methodsFor: 'instance creation' stamp: 'bar 12/13/2004 17:26'!
initialize
	super initialize.
	types := OrderedCollection new.
	hasSend := false.
	contextCount := 0! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 12/1/2004 21:47'!
interpretNextInstructionUsing: aScanner 
	found := false.
	aScanner interpretNextInstructionFor: self.
	^found
! !

!ECVarTypeGuesser methodsFor: 'public' stamp: 'bar 3/20/2006 15:59'!
methodRefs
	^Array new! !

!ECVarTypeGuesser methodsFor: 'public' stamp: 'ul 9/29/2010 22:00'!
perform
	| minPriorityInfo  methodRefs |
	variableName isEmpty
		ifTrue: [^ nil].
	methodRefs := self methodRefs.
	methodRefs
		ifNil: [^ nil]. 
	methodRefs isBehavior
		ifTrue: [^ methodRefs].
	contextCount := 0.
	minPriorityInfo := nil.
	methodRefs do: [:each | 
		| infosOfMethod |
		self prepare: each.
		infosOfMethod := self typeOfVarIn: each compiledMethod.
		(infosOfMethod detectMin: #priority) ifNotNil: [ :possibleMinPrioriotyInfo |
			minPriorityInfo 
				ifNil: [ minPriorityInfo := possibleMinPrioriotyInfo ]
				ifNotNil: [ 
					minPriorityInfo priority <= possibleMinPrioriotyInfo priority
						ifFalse: [ minPriorityInfo := possibleMinPrioriotyInfo ] ] ] ].
	^minPriorityInfo ifNotNil: [ minPriorityInfo type ]! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 8/11/2005 13:03'!
popIntoLiteralVariable: anAssociation 
	"Remove Top Of Stack And Store Into Literal Variable bytecode."
	self reset! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 12/13/2004 17:08'!
popIntoTemporaryVariable: offset 
	"Remove Top Of Stack And Store Into Temporary Variable bytecode."
	self reset
! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 8/11/2005 13:19'!
prepare: aCompiledMethod ! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'lr 7/4/2009 10:42'!
pushActiveContext
	"Push Active Context On Top Of Its Own Stack bytecode."
	contextCount := contextCount + 1! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'lr 7/4/2009 10:42'!
pushConstant: value 
	"Push Constant, value, on Top Of Stack bytecode."
	| info |
	contextCount > 0 ifTrue: [ ^ self ].
	value ifNotNil: 
		[ info := ECTypeInfo definedByLiteral: value class.
		types add: info ]! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 12/13/2004 17:15'!
pushLiteralVariable: anAssociation 
	"Push Contents Of anAssociation On Top Of Stack bytecode."
	| info |
	contextCount > 0 ifTrue:[^self].

	info := ECTypeInfo definedByMessageSend: anAssociation value.
	types add: info! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 12/13/2004 17:15'!
pushTemporaryVariable: offset 
	"Push Contents Of Temporary Variable Whose Index Is the  
	argument, offset, On Top Of Stack bytecode."
	| info |
		contextCount > 0 ifTrue:[^self].

	info := ECTypeInfo definedByTemporaryVar: offset.
	types add: info! !

!ECVarTypeGuesser methodsFor: 'private' stamp: 'bar 12/13/2004 17:14'!
reset
	contextCount > 0 ifTrue:[^self].
	types reset.
	hasSend := false.! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'bar 12/13/2004 17:15'!
send: selector super: supered numArgs: numberArguments 
	"Send Message With Selector, selector, bytecode. The argument,  
	supered, indicates whether the receiver of the message is specified with 
	'super' in the source method. The arguments of the message are found  
	in  
	the top numArguments locations on the stack and the receiver just  
	below them."
	contextCount > 0 ifTrue:[^self].

	hasSend := true! !

!ECVarTypeGuesser methodsFor: 'instance creation' stamp: 'bar 12/13/2004 13:55'!
setVariableName: aString source: aSourceString class: aClass 
	variableName := aString.
	receiverClass := aClass! !

!ECVarTypeGuesser methodsFor: 'bytecode decoding' stamp: 'lr 7/4/2009 10:42'!
typeOfVarIn: aMethod 
	"Answer whether the receiver references an instance variable."
	| scanner end type infos |
	scanner := InstructionStream on: aMethod.
	end := scanner method endPC.
	currentMethod := aMethod.
	infos := OrderedCollection new.
	[ scanner pc <= end ] whileTrue: 
		[ (self interpretNextInstructionUsing: scanner) ifTrue: 
			[ type := self computeVarType.
			type ifNotNil: [ infos add: type ] ] ].
	^ infos! !

!CodeHolder methodsFor: '*Ocompletion-override' stamp: 'bar 12/13/2004 14:39'!
contentsChanged
	super contentsChanged.
	self changed: #annotation.
	self completionController closeMenu! !

!CodeHolder methodsFor: '*Ocompletion' stamp: 'bar 11/30/2004 16:10'!
receiverClass
	^ self selectedClassOrMetaClass! !

!SmalltalkEditor methodsFor: '*Ocompletion' stamp: 'djr 1/4/2010 20:56'!
caret
	^self startBlock stringIndex! !

!SmalltalkEditor methodsFor: '*Ocompletion' stamp: 'djr 1/4/2010 21:13'!
isCaretBehindChar
	| pos |
	pos := self caret - 1.
	^ pos < 1
		ifTrue: [false]
		ifFalse: [(self text at: pos) isAlphaNumeric]! !

!SmalltalkEditor methodsFor: '*Ocompletion' stamp: 'ul 10/3/2010 22:18'!
model

	^model! !

!SmalltalkEditor methodsFor: '*Ocompletion' stamp: 'MarianoMartinezPeck 12/2/2010 11:52'!
selectionPosition: aString

	| caret |
	caret := self caret.
	^[
		| bottomLeft topLeft |
		self selectAt: caret - aString size.
		bottomLeft := self paragraph selectionRects first bottomLeft.
		topLeft := self morph owner submorphBounds topLeft.
		topLeft + bottomLeft ]
			ensure: [ self selectAt: caret ]! !

!SmalltalkEditor methodsFor: '*Ocompletion' stamp: 'MarianoMartinezPeck 12/2/2010 11:52'!
wordAtCaret
	^self paragraph text asString wordBefore: self caret -1
! !
ECPreferences initialize!
OCompletionTable initialize!
